// $ANTLR 3.5 /compiler_study/CShell/antlr/CShell.g 2013-01-11 22:18:18

package cshell.interpreter;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;


@SuppressWarnings("all")
public class CShellParser extends Parser {
	public static final String[] tokenNames = new String[] {
		"<invalid>", "<EOR>", "<DOWN>", "<UP>", "ADD", "ARGS", "ARRAY", "ARRAY_ELEMENT", 
		"ASSIGN", "BLOCK", "CALL", "CHAR", "DEC", "DEF", "DIV", "ELSE", "ELSEIF", 
		"EQ", "FIELDS", "FLOAT", "FOR", "FOR1", "FOR2", "FOR3", "GT", "ID", "IF", 
		"INC", "INT", "LENGTH", "LETTER", "LT", "MUL", "NL", "PREV", "PRINT", 
		"RETURN", "SL_COMMENT", "STRING", "SUB", "SUFFIX", "WS", "'('", "')'", 
		"'++'", "','", "'--'", "';'", "'['", "']'", "'else'", "'{'", "'}'"
	};
	public static final int EOF=-1;
	public static final int T__42=42;
	public static final int T__43=43;
	public static final int T__44=44;
	public static final int T__45=45;
	public static final int T__46=46;
	public static final int T__47=47;
	public static final int T__48=48;
	public static final int T__49=49;
	public static final int T__50=50;
	public static final int T__51=51;
	public static final int T__52=52;
	public static final int ADD=4;
	public static final int ARGS=5;
	public static final int ARRAY=6;
	public static final int ARRAY_ELEMENT=7;
	public static final int ASSIGN=8;
	public static final int BLOCK=9;
	public static final int CALL=10;
	public static final int CHAR=11;
	public static final int DEC=12;
	public static final int DEF=13;
	public static final int DIV=14;
	public static final int ELSE=15;
	public static final int ELSEIF=16;
	public static final int EQ=17;
	public static final int FIELDS=18;
	public static final int FLOAT=19;
	public static final int FOR=20;
	public static final int FOR1=21;
	public static final int FOR2=22;
	public static final int FOR3=23;
	public static final int GT=24;
	public static final int ID=25;
	public static final int IF=26;
	public static final int INC=27;
	public static final int INT=28;
	public static final int LENGTH=29;
	public static final int LETTER=30;
	public static final int LT=31;
	public static final int MUL=32;
	public static final int NL=33;
	public static final int PREV=34;
	public static final int PRINT=35;
	public static final int RETURN=36;
	public static final int SL_COMMENT=37;
	public static final int STRING=38;
	public static final int SUB=39;
	public static final int SUFFIX=40;
	public static final int WS=41;

	// delegates
	public Parser[] getDelegates() {
		return new Parser[] {};
	}

	// delegators


	public CShellParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}
	public CShellParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);
	}

	protected TreeAdaptor adaptor = new CommonTreeAdaptor();

	public void setTreeAdaptor(TreeAdaptor adaptor) {
		this.adaptor = adaptor;
	}
	public TreeAdaptor getTreeAdaptor() {
		return adaptor;
	}
	@Override public String[] getTokenNames() { return CShellParser.tokenNames; }
	@Override public String getGrammarFileName() { return "/compiler_study/CShell/antlr/CShell.g"; }


	    Interpreter interp;
	    Scope currentScope;
	    public CShellParser(TokenStream input, Interpreter interp) {
	        this(input);
	        this.interp = interp;
	        currentScope = interp.globalScope;
	    }


	public static class program_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "program"
	// /compiler_study/CShell/antlr/CShell.g:28:1: program : ( function_definition | statement )* EOF -> ^( BLOCK ( statement )* ) ;
	public final CShellParser.program_return program() throws RecognitionException {
		CShellParser.program_return retval = new CShellParser.program_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token EOF3=null;
		ParserRuleReturnScope function_definition1 =null;
		ParserRuleReturnScope statement2 =null;

		CShellAST EOF3_tree=null;
		RewriteRuleTokenStream stream_EOF=new RewriteRuleTokenStream(adaptor,"token EOF");
		RewriteRuleSubtreeStream stream_statement=new RewriteRuleSubtreeStream(adaptor,"rule statement");
		RewriteRuleSubtreeStream stream_function_definition=new RewriteRuleSubtreeStream(adaptor,"rule function_definition");

		try {
			// /compiler_study/CShell/antlr/CShell.g:29:2: ( ( function_definition | statement )* EOF -> ^( BLOCK ( statement )* ) )
			// /compiler_study/CShell/antlr/CShell.g:29:4: ( function_definition | statement )* EOF
			{
			// /compiler_study/CShell/antlr/CShell.g:29:4: ( function_definition | statement )*
			loop1:
			while (true) {
				int alt1=3;
				int LA1_0 = input.LA(1);
				if ( (LA1_0==DEF) ) {
					alt1=1;
				}
				else if ( (LA1_0==FOR||(LA1_0 >= ID && LA1_0 <= IF)||LA1_0==NL||(LA1_0 >= PRINT && LA1_0 <= RETURN)||LA1_0==44||LA1_0==46) ) {
					alt1=2;
				}

				switch (alt1) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:29:5: function_definition
					{
					pushFollow(FOLLOW_function_definition_in_program164);
					function_definition1=function_definition();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_function_definition.add(function_definition1.getTree());
					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:29:26: statement
					{
					pushFollow(FOLLOW_statement_in_program167);
					statement2=statement();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_statement.add(statement2.getTree());
					}
					break;

				default :
					break loop1;
				}
			}

			EOF3=(Token)match(input,EOF,FOLLOW_EOF_in_program171); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_EOF.add(EOF3);

			// AST REWRITE
			// elements: statement
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 30:3: -> ^( BLOCK ( statement )* )
			{
				// /compiler_study/CShell/antlr/CShell.g:30:6: ^( BLOCK ( statement )* )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(BLOCK, "BLOCK"), root_1);
				// /compiler_study/CShell/antlr/CShell.g:30:14: ( statement )*
				while ( stream_statement.hasNext() ) {
					adaptor.addChild(root_1, stream_statement.nextTree());
				}
				stream_statement.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "program"


	public static class statement_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "statement"
	// /compiler_study/CShell/antlr/CShell.g:32:1: statement : ( assign ^ ';' | inc_dec ^ ';' | 'return' expr ';' -> ^( 'return' expr ) | 'print' '(' expr ')' ';' -> ^( 'print' expr ) | 'if' '(' expr ')' slist elseif_statement_all ( else_statement )? -> ^( 'if' expr slist elseif_statement_all ^( ELSE ( else_statement )? ) ) | for_statement | array_statement_init | call ';' -> call | NL ->);
	public final CShellParser.statement_return statement() throws RecognitionException {
		CShellParser.statement_return retval = new CShellParser.statement_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token char_literal5=null;
		Token char_literal7=null;
		Token string_literal8=null;
		Token char_literal10=null;
		Token string_literal11=null;
		Token char_literal12=null;
		Token char_literal14=null;
		Token char_literal15=null;
		Token string_literal16=null;
		Token char_literal17=null;
		Token char_literal19=null;
		Token char_literal26=null;
		Token NL27=null;
		ParserRuleReturnScope assign4 =null;
		ParserRuleReturnScope inc_dec6 =null;
		ParserRuleReturnScope expr9 =null;
		ParserRuleReturnScope expr13 =null;
		ParserRuleReturnScope expr18 =null;
		ParserRuleReturnScope slist20 =null;
		ParserRuleReturnScope elseif_statement_all21 =null;
		ParserRuleReturnScope else_statement22 =null;
		ParserRuleReturnScope for_statement23 =null;
		ParserRuleReturnScope array_statement_init24 =null;
		ParserRuleReturnScope call25 =null;

		CShellAST char_literal5_tree=null;
		CShellAST char_literal7_tree=null;
		CShellAST string_literal8_tree=null;
		CShellAST char_literal10_tree=null;
		CShellAST string_literal11_tree=null;
		CShellAST char_literal12_tree=null;
		CShellAST char_literal14_tree=null;
		CShellAST char_literal15_tree=null;
		CShellAST string_literal16_tree=null;
		CShellAST char_literal17_tree=null;
		CShellAST char_literal19_tree=null;
		CShellAST char_literal26_tree=null;
		CShellAST NL27_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_NL=new RewriteRuleTokenStream(adaptor,"token NL");
		RewriteRuleTokenStream stream_47=new RewriteRuleTokenStream(adaptor,"token 47");
		RewriteRuleTokenStream stream_PRINT=new RewriteRuleTokenStream(adaptor,"token PRINT");
		RewriteRuleTokenStream stream_IF=new RewriteRuleTokenStream(adaptor,"token IF");
		RewriteRuleTokenStream stream_RETURN=new RewriteRuleTokenStream(adaptor,"token RETURN");
		RewriteRuleSubtreeStream stream_elseif_statement_all=new RewriteRuleSubtreeStream(adaptor,"rule elseif_statement_all");
		RewriteRuleSubtreeStream stream_call=new RewriteRuleSubtreeStream(adaptor,"rule call");
		RewriteRuleSubtreeStream stream_else_statement=new RewriteRuleSubtreeStream(adaptor,"rule else_statement");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
		RewriteRuleSubtreeStream stream_slist=new RewriteRuleSubtreeStream(adaptor,"rule slist");

		try {
			// /compiler_study/CShell/antlr/CShell.g:33:2: ( assign ^ ';' | inc_dec ^ ';' | 'return' expr ';' -> ^( 'return' expr ) | 'print' '(' expr ')' ';' -> ^( 'print' expr ) | 'if' '(' expr ')' slist elseif_statement_all ( else_statement )? -> ^( 'if' expr slist elseif_statement_all ^( ELSE ( else_statement )? ) ) | for_statement | array_statement_init | call ';' -> call | NL ->)
			int alt3=9;
			switch ( input.LA(1) ) {
			case ID:
				{
				int LA3_1 = input.LA(2);
				if ( (synpred3_CShell()) ) {
					alt3=1;
				}
				else if ( (synpred4_CShell()) ) {
					alt3=2;
				}
				else if ( (synpred10_CShell()) ) {
					alt3=7;
				}
				else if ( (synpred11_CShell()) ) {
					alt3=8;
				}

				else {
					if (state.backtracking>0) {state.failed=true; return retval;}
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 3, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

				}
				break;
			case 44:
			case 46:
				{
				alt3=2;
				}
				break;
			case RETURN:
				{
				alt3=3;
				}
				break;
			case PRINT:
				{
				alt3=4;
				}
				break;
			case IF:
				{
				alt3=5;
				}
				break;
			case FOR:
				{
				alt3=6;
				}
				break;
			case NL:
				{
				alt3=9;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 3, 0, input);
				throw nvae;
			}
			switch (alt3) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:33:4: assign ^ ';'
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_assign_in_statement192);
					assign4=assign();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot(assign4.getTree(), root_0);
					char_literal5=(Token)match(input,47,FOLLOW_47_in_statement195); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					char_literal5_tree = (CShellAST)adaptor.create(char_literal5);
					adaptor.addChild(root_0, char_literal5_tree);
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:34:6: inc_dec ^ ';'
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_inc_dec_in_statement206);
					inc_dec6=inc_dec();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot(inc_dec6.getTree(), root_0);
					char_literal7=(Token)match(input,47,FOLLOW_47_in_statement208); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					char_literal7_tree = (CShellAST)adaptor.create(char_literal7);
					adaptor.addChild(root_0, char_literal7_tree);
					}

					}
					break;
				case 3 :
					// /compiler_study/CShell/antlr/CShell.g:35:4: 'return' expr ';'
					{
					string_literal8=(Token)match(input,RETURN,FOLLOW_RETURN_in_statement225); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_RETURN.add(string_literal8);

					pushFollow(FOLLOW_expr_in_statement227);
					expr9=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr9.getTree());
					char_literal10=(Token)match(input,47,FOLLOW_47_in_statement229); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_47.add(char_literal10);

					// AST REWRITE
					// elements: expr, RETURN
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 35:26: -> ^( 'return' expr )
					{
						// /compiler_study/CShell/antlr/CShell.g:35:29: ^( 'return' expr )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot(stream_RETURN.nextNode(), root_1);
						adaptor.addChild(root_1, stream_expr.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 4 :
					// /compiler_study/CShell/antlr/CShell.g:36:4: 'print' '(' expr ')' ';'
					{
					string_literal11=(Token)match(input,PRINT,FOLLOW_PRINT_in_statement246); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_PRINT.add(string_literal11);

					char_literal12=(Token)match(input,42,FOLLOW_42_in_statement248); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_42.add(char_literal12);

					pushFollow(FOLLOW_expr_in_statement250);
					expr13=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr13.getTree());
					char_literal14=(Token)match(input,43,FOLLOW_43_in_statement252); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_43.add(char_literal14);

					char_literal15=(Token)match(input,47,FOLLOW_47_in_statement254); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_47.add(char_literal15);

					// AST REWRITE
					// elements: expr, PRINT
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 36:33: -> ^( 'print' expr )
					{
						// /compiler_study/CShell/antlr/CShell.g:36:36: ^( 'print' expr )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot(stream_PRINT.nextNode(), root_1);
						adaptor.addChild(root_1, stream_expr.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 5 :
					// /compiler_study/CShell/antlr/CShell.g:37:4: 'if' '(' expr ')' slist elseif_statement_all ( else_statement )?
					{
					string_literal16=(Token)match(input,IF,FOLLOW_IF_in_statement271); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_IF.add(string_literal16);

					char_literal17=(Token)match(input,42,FOLLOW_42_in_statement273); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_42.add(char_literal17);

					pushFollow(FOLLOW_expr_in_statement275);
					expr18=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr18.getTree());
					char_literal19=(Token)match(input,43,FOLLOW_43_in_statement277); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_43.add(char_literal19);

					pushFollow(FOLLOW_slist_in_statement279);
					slist20=slist();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_slist.add(slist20.getTree());
					pushFollow(FOLLOW_elseif_statement_all_in_statement281);
					elseif_statement_all21=elseif_statement_all();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_elseif_statement_all.add(elseif_statement_all21.getTree());
					// /compiler_study/CShell/antlr/CShell.g:37:50: ( else_statement )?
					int alt2=2;
					int LA2_0 = input.LA(1);
					if ( (LA2_0==50) ) {
						alt2=1;
					}
					switch (alt2) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:37:50: else_statement
							{
							pushFollow(FOLLOW_else_statement_in_statement284);
							else_statement22=else_statement();
							state._fsp--;
							if (state.failed) return retval;
							if ( state.backtracking==0 ) stream_else_statement.add(else_statement22.getTree());
							}
							break;

					}

					// AST REWRITE
					// elements: IF, expr, slist, elseif_statement_all, else_statement
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 38:6: -> ^( 'if' expr slist elseif_statement_all ^( ELSE ( else_statement )? ) )
					{
						// /compiler_study/CShell/antlr/CShell.g:38:9: ^( 'if' expr slist elseif_statement_all ^( ELSE ( else_statement )? ) )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot(stream_IF.nextNode(), root_1);
						adaptor.addChild(root_1, stream_expr.nextTree());
						adaptor.addChild(root_1, stream_slist.nextTree());
						adaptor.addChild(root_1, stream_elseif_statement_all.nextTree());
						// /compiler_study/CShell/antlr/CShell.g:38:48: ^( ELSE ( else_statement )? )
						{
						CShellAST root_2 = (CShellAST)adaptor.nil();
						root_2 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(ELSE, "ELSE"), root_2);
						// /compiler_study/CShell/antlr/CShell.g:38:55: ( else_statement )?
						if ( stream_else_statement.hasNext() ) {
							adaptor.addChild(root_2, stream_else_statement.nextTree());
						}
						stream_else_statement.reset();

						adaptor.addChild(root_1, root_2);
						}

						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 6 :
					// /compiler_study/CShell/antlr/CShell.g:39:4: for_statement
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_for_statement_in_statement315);
					for_statement23=for_statement();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, for_statement23.getTree());

					}
					break;
				case 7 :
					// /compiler_study/CShell/antlr/CShell.g:40:6: array_statement_init
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_array_statement_init_in_statement322);
					array_statement_init24=array_statement_init();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, array_statement_init24.getTree());

					}
					break;
				case 8 :
					// /compiler_study/CShell/antlr/CShell.g:41:6: call ';'
					{
					pushFollow(FOLLOW_call_in_statement329);
					call25=call();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_call.add(call25.getTree());
					char_literal26=(Token)match(input,47,FOLLOW_47_in_statement331); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_47.add(char_literal26);

					// AST REWRITE
					// elements: call
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 41:34: -> call
					{
						adaptor.addChild(root_0, stream_call.nextTree());
					}


					retval.tree = root_0;
					}

					}
					break;
				case 9 :
					// /compiler_study/CShell/antlr/CShell.g:42:4: NL
					{
					NL27=(Token)match(input,NL,FOLLOW_NL_in_statement358); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_NL.add(NL27);

					// AST REWRITE
					// elements: 
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 42:13: ->
					{
						root_0 = null;
					}


					retval.tree = root_0;
					}

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "statement"


	public static class function_definition_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "function_definition"
	// /compiler_study/CShell/antlr/CShell.g:45:1: function_definition : 'def' ID '(' ( vardef ( ',' vardef )* )? ')' slist ->;
	public final CShellParser.function_definition_return function_definition() throws RecognitionException {
		CShellParser.function_definition_return retval = new CShellParser.function_definition_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal28=null;
		Token ID29=null;
		Token char_literal30=null;
		Token char_literal32=null;
		Token char_literal34=null;
		ParserRuleReturnScope vardef31 =null;
		ParserRuleReturnScope vardef33 =null;
		ParserRuleReturnScope slist35 =null;

		CShellAST string_literal28_tree=null;
		CShellAST ID29_tree=null;
		CShellAST char_literal30_tree=null;
		CShellAST char_literal32_tree=null;
		CShellAST char_literal34_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_45=new RewriteRuleTokenStream(adaptor,"token 45");
		RewriteRuleTokenStream stream_DEF=new RewriteRuleTokenStream(adaptor,"token DEF");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
		RewriteRuleSubtreeStream stream_vardef=new RewriteRuleSubtreeStream(adaptor,"rule vardef");
		RewriteRuleSubtreeStream stream_slist=new RewriteRuleSubtreeStream(adaptor,"rule slist");

		FunctionSymbol fs = null;
		try {
			// /compiler_study/CShell/antlr/CShell.g:46:2: ( 'def' ID '(' ( vardef ( ',' vardef )* )? ')' slist ->)
			// /compiler_study/CShell/antlr/CShell.g:46:4: 'def' ID '(' ( vardef ( ',' vardef )* )? ')' slist
			{
			string_literal28=(Token)match(input,DEF,FOLLOW_DEF_in_function_definition383); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_DEF.add(string_literal28);

			ID29=(Token)match(input,ID,FOLLOW_ID_in_function_definition385); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ID.add(ID29);

			if ( state.backtracking==0 ) {
			        fs = new FunctionSymbol((ID29!=null?ID29.getText():null),currentScope);
			        currentScope.define(fs); // def method in globals
			        currentScope = fs;       // set current scope to method scope
			        }
			char_literal30=(Token)match(input,42,FOLLOW_42_in_function_definition400); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_42.add(char_literal30);

			// /compiler_study/CShell/antlr/CShell.g:52:13: ( vardef ( ',' vardef )* )?
			int alt5=2;
			int LA5_0 = input.LA(1);
			if ( (LA5_0==ID) ) {
				alt5=1;
			}
			switch (alt5) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:52:14: vardef ( ',' vardef )*
					{
					pushFollow(FOLLOW_vardef_in_function_definition403);
					vardef31=vardef();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_vardef.add(vardef31.getTree());
					// /compiler_study/CShell/antlr/CShell.g:52:21: ( ',' vardef )*
					loop4:
					while (true) {
						int alt4=2;
						int LA4_0 = input.LA(1);
						if ( (LA4_0==45) ) {
							alt4=1;
						}

						switch (alt4) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:52:22: ',' vardef
							{
							char_literal32=(Token)match(input,45,FOLLOW_45_in_function_definition406); if (state.failed) return retval; 
							if ( state.backtracking==0 ) stream_45.add(char_literal32);

							pushFollow(FOLLOW_vardef_in_function_definition408);
							vardef33=vardef();
							state._fsp--;
							if (state.failed) return retval;
							if ( state.backtracking==0 ) stream_vardef.add(vardef33.getTree());
							}
							break;

						default :
							break loop4;
						}
					}

					}
					break;

			}

			char_literal34=(Token)match(input,43,FOLLOW_43_in_function_definition415); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_43.add(char_literal34);

			if ( state.backtracking==0 ) {/*currentScope = new LocalScope(fs);*/}
			pushFollow(FOLLOW_slist_in_function_definition425);
			slist35=slist();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_slist.add(slist35.getTree());
			if ( state.backtracking==0 ) {
					fs.blockAST = (slist35!=null?((CShellAST)slist35.getTree()):null);
					//System.out.println(currentScope.getScopeName());
					currentScope = currentScope.getEnclosingScope();  //  ָFunctionSymbol
					//  meָGlobal Scope
					
				    //System.out.println(currentScope.getScopeName());
					}
			// AST REWRITE
			// elements: 
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 63:3: ->
			{
				root_0 = null;
			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "function_definition"


	public static class vardef_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "vardef"
	// /compiler_study/CShell/antlr/CShell.g:65:1: vardef : ID ;
	public final CShellParser.vardef_return vardef() throws RecognitionException {
		CShellParser.vardef_return retval = new CShellParser.vardef_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token ID36=null;

		CShellAST ID36_tree=null;

		VariableSymbol vs = null;
		try {
			// /compiler_study/CShell/antlr/CShell.g:66:2: ( ID )
			// /compiler_study/CShell/antlr/CShell.g:66:4: ID
			{
			root_0 = (CShellAST)adaptor.nil();


			ID36=(Token)match(input,ID,FOLLOW_ID_in_vardef448); if (state.failed) return retval;
			if ( state.backtracking==0 ) {
			ID36_tree = (CShellAST)adaptor.create(ID36);
			adaptor.addChild(root_0, ID36_tree);
			}

			if ( state.backtracking==0 ) {
					ID36_tree.scope = currentScope;
					vs = new VariableSymbol((ID36!=null?ID36.getText():null));
					currentScope.define(vs);
					}
			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "vardef"


	public static class call_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "call"
	// /compiler_study/CShell/antlr/CShell.g:73:1: call : ID '(' ( expr ( ',' expr )* )? ')' -> ^( CALL ID ( expr )* ) ;
	public final CShellParser.call_return call() throws RecognitionException {
		CShellParser.call_return retval = new CShellParser.call_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token ID37=null;
		Token char_literal38=null;
		Token char_literal40=null;
		Token char_literal42=null;
		ParserRuleReturnScope expr39 =null;
		ParserRuleReturnScope expr41 =null;

		CShellAST ID37_tree=null;
		CShellAST char_literal38_tree=null;
		CShellAST char_literal40_tree=null;
		CShellAST char_literal42_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_45=new RewriteRuleTokenStream(adaptor,"token 45");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

		try {
			// /compiler_study/CShell/antlr/CShell.g:78:2: ( ID '(' ( expr ( ',' expr )* )? ')' -> ^( CALL ID ( expr )* ) )
			// /compiler_study/CShell/antlr/CShell.g:78:4: ID '(' ( expr ( ',' expr )* )? ')'
			{
			ID37=(Token)match(input,ID,FOLLOW_ID_in_call467); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ID.add(ID37);

			char_literal38=(Token)match(input,42,FOLLOW_42_in_call469); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_42.add(char_literal38);

			// /compiler_study/CShell/antlr/CShell.g:78:11: ( expr ( ',' expr )* )?
			int alt7=2;
			int LA7_0 = input.LA(1);
			if ( (LA7_0==CHAR||LA7_0==FLOAT||LA7_0==ID||(LA7_0 >= INT && LA7_0 <= LENGTH)||LA7_0==STRING||LA7_0==42||LA7_0==44||LA7_0==46) ) {
				alt7=1;
			}
			switch (alt7) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:78:12: expr ( ',' expr )*
					{
					pushFollow(FOLLOW_expr_in_call472);
					expr39=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr39.getTree());
					// /compiler_study/CShell/antlr/CShell.g:78:17: ( ',' expr )*
					loop6:
					while (true) {
						int alt6=2;
						int LA6_0 = input.LA(1);
						if ( (LA6_0==45) ) {
							alt6=1;
						}

						switch (alt6) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:78:18: ',' expr
							{
							char_literal40=(Token)match(input,45,FOLLOW_45_in_call475); if (state.failed) return retval; 
							if ( state.backtracking==0 ) stream_45.add(char_literal40);

							pushFollow(FOLLOW_expr_in_call477);
							expr41=expr();
							state._fsp--;
							if (state.failed) return retval;
							if ( state.backtracking==0 ) stream_expr.add(expr41.getTree());
							}
							break;

						default :
							break loop6;
						}
					}

					}
					break;

			}

			char_literal42=(Token)match(input,43,FOLLOW_43_in_call484); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_43.add(char_literal42);

			// AST REWRITE
			// elements: ID, expr
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 78:36: -> ^( CALL ID ( expr )* )
			{
				// /compiler_study/CShell/antlr/CShell.g:78:39: ^( CALL ID ( expr )* )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(CALL, "CALL"), root_1);
				adaptor.addChild(root_1, stream_ID.nextNode());
				// /compiler_study/CShell/antlr/CShell.g:78:49: ( expr )*
				while ( stream_expr.hasNext() ) {
					adaptor.addChild(root_1, stream_expr.nextTree());
				}
				stream_expr.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
			if ( state.backtracking==0 ) {
				retval.tree.scope = currentScope;
				//retval.tree.symbol = currentScope.resolve($name.text);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "call"


	public static class else_statement_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "else_statement"
	// /compiler_study/CShell/antlr/CShell.g:80:1: else_statement : 'else' slist -> slist ;
	public final CShellParser.else_statement_return else_statement() throws RecognitionException {
		CShellParser.else_statement_return retval = new CShellParser.else_statement_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal43=null;
		ParserRuleReturnScope slist44 =null;

		CShellAST string_literal43_tree=null;
		RewriteRuleTokenStream stream_50=new RewriteRuleTokenStream(adaptor,"token 50");
		RewriteRuleSubtreeStream stream_slist=new RewriteRuleSubtreeStream(adaptor,"rule slist");

		try {
			// /compiler_study/CShell/antlr/CShell.g:80:15: ( 'else' slist -> slist )
			// /compiler_study/CShell/antlr/CShell.g:80:16: 'else' slist
			{
			string_literal43=(Token)match(input,50,FOLLOW_50_in_else_statement503); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_50.add(string_literal43);

			pushFollow(FOLLOW_slist_in_else_statement505);
			slist44=slist();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_slist.add(slist44.getTree());
			// AST REWRITE
			// elements: slist
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 80:28: -> slist
			{
				adaptor.addChild(root_0, stream_slist.nextTree());
			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "else_statement"


	public static class elseif_statement_all_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "elseif_statement_all"
	// /compiler_study/CShell/antlr/CShell.g:81:1: elseif_statement_all : ( 'else' 'if' '(' expr ')' slist )* -> ^( ELSEIF ( ^( ELSEIF expr slist ) )* ) ;
	public final CShellParser.elseif_statement_all_return elseif_statement_all() throws RecognitionException {
		CShellParser.elseif_statement_all_return retval = new CShellParser.elseif_statement_all_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal45=null;
		Token string_literal46=null;
		Token char_literal47=null;
		Token char_literal49=null;
		ParserRuleReturnScope expr48 =null;
		ParserRuleReturnScope slist50 =null;

		CShellAST string_literal45_tree=null;
		CShellAST string_literal46_tree=null;
		CShellAST char_literal47_tree=null;
		CShellAST char_literal49_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_IF=new RewriteRuleTokenStream(adaptor,"token IF");
		RewriteRuleTokenStream stream_50=new RewriteRuleTokenStream(adaptor,"token 50");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
		RewriteRuleSubtreeStream stream_slist=new RewriteRuleSubtreeStream(adaptor,"rule slist");

		try {
			// /compiler_study/CShell/antlr/CShell.g:81:21: ( ( 'else' 'if' '(' expr ')' slist )* -> ^( ELSEIF ( ^( ELSEIF expr slist ) )* ) )
			// /compiler_study/CShell/antlr/CShell.g:81:23: ( 'else' 'if' '(' expr ')' slist )*
			{
			// /compiler_study/CShell/antlr/CShell.g:81:23: ( 'else' 'if' '(' expr ')' slist )*
			loop8:
			while (true) {
				int alt8=2;
				int LA8_0 = input.LA(1);
				if ( (LA8_0==50) ) {
					int LA8_1 = input.LA(2);
					if ( (LA8_1==IF) ) {
						alt8=1;
					}

				}

				switch (alt8) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:81:24: 'else' 'if' '(' expr ')' slist
					{
					string_literal45=(Token)match(input,50,FOLLOW_50_in_elseif_statement_all515); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_50.add(string_literal45);

					string_literal46=(Token)match(input,IF,FOLLOW_IF_in_elseif_statement_all517); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_IF.add(string_literal46);

					char_literal47=(Token)match(input,42,FOLLOW_42_in_elseif_statement_all519); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_42.add(char_literal47);

					pushFollow(FOLLOW_expr_in_elseif_statement_all521);
					expr48=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr48.getTree());
					char_literal49=(Token)match(input,43,FOLLOW_43_in_elseif_statement_all523); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_43.add(char_literal49);

					pushFollow(FOLLOW_slist_in_elseif_statement_all526);
					slist50=slist();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_slist.add(slist50.getTree());
					}
					break;

				default :
					break loop8;
				}
			}

			// AST REWRITE
			// elements: expr, slist
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 81:58: -> ^( ELSEIF ( ^( ELSEIF expr slist ) )* )
			{
				// /compiler_study/CShell/antlr/CShell.g:81:60: ^( ELSEIF ( ^( ELSEIF expr slist ) )* )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(ELSEIF, "ELSEIF"), root_1);
				// /compiler_study/CShell/antlr/CShell.g:81:69: ( ^( ELSEIF expr slist ) )*
				while ( stream_expr.hasNext()||stream_slist.hasNext() ) {
					// /compiler_study/CShell/antlr/CShell.g:81:69: ^( ELSEIF expr slist )
					{
					CShellAST root_2 = (CShellAST)adaptor.nil();
					root_2 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(ELSEIF, "ELSEIF"), root_2);
					adaptor.addChild(root_2, stream_expr.nextTree());
					adaptor.addChild(root_2, stream_slist.nextTree());
					adaptor.addChild(root_1, root_2);
					}

				}
				stream_expr.reset();
				stream_slist.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "elseif_statement_all"


	public static class for_statement_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "for_statement"
	// /compiler_study/CShell/antlr/CShell.g:83:1: for_statement : 'for' '(' ( for1 )? ';' ( for2 )? ';' ( for3 )? ')' slist -> ^( 'for' ^( FOR1 ( for1 )? ) ^( FOR2 ( for2 )? ) ^( FOR3 ( for3 )? ) slist ) ;
	public final CShellParser.for_statement_return for_statement() throws RecognitionException {
		CShellParser.for_statement_return retval = new CShellParser.for_statement_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal51=null;
		Token char_literal52=null;
		Token char_literal54=null;
		Token char_literal56=null;
		Token char_literal58=null;
		ParserRuleReturnScope for153 =null;
		ParserRuleReturnScope for255 =null;
		ParserRuleReturnScope for357 =null;
		ParserRuleReturnScope slist59 =null;

		CShellAST string_literal51_tree=null;
		CShellAST char_literal52_tree=null;
		CShellAST char_literal54_tree=null;
		CShellAST char_literal56_tree=null;
		CShellAST char_literal58_tree=null;
		RewriteRuleTokenStream stream_FOR=new RewriteRuleTokenStream(adaptor,"token FOR");
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_47=new RewriteRuleTokenStream(adaptor,"token 47");
		RewriteRuleSubtreeStream stream_for1=new RewriteRuleSubtreeStream(adaptor,"rule for1");
		RewriteRuleSubtreeStream stream_for2=new RewriteRuleSubtreeStream(adaptor,"rule for2");
		RewriteRuleSubtreeStream stream_slist=new RewriteRuleSubtreeStream(adaptor,"rule slist");
		RewriteRuleSubtreeStream stream_for3=new RewriteRuleSubtreeStream(adaptor,"rule for3");

		try {
			// /compiler_study/CShell/antlr/CShell.g:84:2: ( 'for' '(' ( for1 )? ';' ( for2 )? ';' ( for3 )? ')' slist -> ^( 'for' ^( FOR1 ( for1 )? ) ^( FOR2 ( for2 )? ) ^( FOR3 ( for3 )? ) slist ) )
			// /compiler_study/CShell/antlr/CShell.g:85:2: 'for' '(' ( for1 )? ';' ( for2 )? ';' ( for3 )? ')' slist
			{
			string_literal51=(Token)match(input,FOR,FOLLOW_FOR_in_for_statement553); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_FOR.add(string_literal51);

			char_literal52=(Token)match(input,42,FOLLOW_42_in_for_statement555); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_42.add(char_literal52);

			if ( state.backtracking==0 ) {currentScope = new LocalScope(currentScope);
				            
				          }
			// /compiler_study/CShell/antlr/CShell.g:89:12: ( for1 )?
			int alt9=2;
			int LA9_0 = input.LA(1);
			if ( (LA9_0==ID) ) {
				alt9=1;
			}
			switch (alt9) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:89:12: for1
					{
					pushFollow(FOLLOW_for1_in_for_statement582);
					for153=for1();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_for1.add(for153.getTree());
					}
					break;

			}

			char_literal54=(Token)match(input,47,FOLLOW_47_in_for_statement608); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_47.add(char_literal54);

			// /compiler_study/CShell/antlr/CShell.g:91:16: ( for2 )?
			int alt10=2;
			int LA10_0 = input.LA(1);
			if ( (LA10_0==CHAR||LA10_0==FLOAT||LA10_0==ID||(LA10_0 >= INT && LA10_0 <= LENGTH)||LA10_0==STRING||LA10_0==42||LA10_0==44||LA10_0==46) ) {
				alt10=1;
			}
			switch (alt10) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:91:16: for2
					{
					pushFollow(FOLLOW_for2_in_for_statement610);
					for255=for2();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_for2.add(for255.getTree());
					}
					break;

			}

			char_literal56=(Token)match(input,47,FOLLOW_47_in_for_statement624); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_47.add(char_literal56);

			// /compiler_study/CShell/antlr/CShell.g:92:16: ( for3 )?
			int alt11=2;
			int LA11_0 = input.LA(1);
			if ( (LA11_0==CHAR||LA11_0==FLOAT||LA11_0==ID||(LA11_0 >= INT && LA11_0 <= LENGTH)||LA11_0==STRING||LA11_0==42||LA11_0==44||LA11_0==46) ) {
				alt11=1;
			}
			switch (alt11) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:92:16: for3
					{
					pushFollow(FOLLOW_for3_in_for_statement626);
					for357=for3();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_for3.add(for357.getTree());
					}
					break;

			}

			char_literal58=(Token)match(input,43,FOLLOW_43_in_for_statement629); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_43.add(char_literal58);

			pushFollow(FOLLOW_slist_in_for_statement631);
			slist59=slist();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_slist.add(slist59.getTree());
			if ( state.backtracking==0 ) {currentScope = currentScope.getEnclosingScope();}
			// AST REWRITE
			// elements: for3, for1, slist, FOR, for2
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 94:8: -> ^( 'for' ^( FOR1 ( for1 )? ) ^( FOR2 ( for2 )? ) ^( FOR3 ( for3 )? ) slist )
			{
				// /compiler_study/CShell/antlr/CShell.g:94:11: ^( 'for' ^( FOR1 ( for1 )? ) ^( FOR2 ( for2 )? ) ^( FOR3 ( for3 )? ) slist )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot(stream_FOR.nextNode(), root_1);
				// /compiler_study/CShell/antlr/CShell.g:94:20: ^( FOR1 ( for1 )? )
				{
				CShellAST root_2 = (CShellAST)adaptor.nil();
				root_2 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(FOR1, "FOR1"), root_2);
				// /compiler_study/CShell/antlr/CShell.g:94:27: ( for1 )?
				if ( stream_for1.hasNext() ) {
					adaptor.addChild(root_2, stream_for1.nextTree());
				}
				stream_for1.reset();

				adaptor.addChild(root_1, root_2);
				}

				// /compiler_study/CShell/antlr/CShell.g:94:34: ^( FOR2 ( for2 )? )
				{
				CShellAST root_2 = (CShellAST)adaptor.nil();
				root_2 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(FOR2, "FOR2"), root_2);
				// /compiler_study/CShell/antlr/CShell.g:94:41: ( for2 )?
				if ( stream_for2.hasNext() ) {
					adaptor.addChild(root_2, stream_for2.nextTree());
				}
				stream_for2.reset();

				adaptor.addChild(root_1, root_2);
				}

				// /compiler_study/CShell/antlr/CShell.g:94:48: ^( FOR3 ( for3 )? )
				{
				CShellAST root_2 = (CShellAST)adaptor.nil();
				root_2 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(FOR3, "FOR3"), root_2);
				// /compiler_study/CShell/antlr/CShell.g:94:55: ( for3 )?
				if ( stream_for3.hasNext() ) {
					adaptor.addChild(root_2, stream_for3.nextTree());
				}
				stream_for3.reset();

				adaptor.addChild(root_1, root_2);
				}

				adaptor.addChild(root_1, stream_slist.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "for_statement"


	public static class for1_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "for1"
	// /compiler_study/CShell/antlr/CShell.g:97:1: for1 : assign ( ',' assign )* -> ( assign )+ ;
	public final CShellParser.for1_return for1() throws RecognitionException {
		CShellParser.for1_return retval = new CShellParser.for1_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token char_literal61=null;
		ParserRuleReturnScope assign60 =null;
		ParserRuleReturnScope assign62 =null;

		CShellAST char_literal61_tree=null;
		RewriteRuleTokenStream stream_45=new RewriteRuleTokenStream(adaptor,"token 45");
		RewriteRuleSubtreeStream stream_assign=new RewriteRuleSubtreeStream(adaptor,"rule assign");

		try {
			// /compiler_study/CShell/antlr/CShell.g:97:10: ( assign ( ',' assign )* -> ( assign )+ )
			// /compiler_study/CShell/antlr/CShell.g:97:13: assign ( ',' assign )*
			{
			pushFollow(FOLLOW_assign_in_for1701);
			assign60=assign();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_assign.add(assign60.getTree());
			// /compiler_study/CShell/antlr/CShell.g:97:19: ( ',' assign )*
			loop12:
			while (true) {
				int alt12=2;
				int LA12_0 = input.LA(1);
				if ( (LA12_0==45) ) {
					alt12=1;
				}

				switch (alt12) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:97:20: ',' assign
					{
					char_literal61=(Token)match(input,45,FOLLOW_45_in_for1703); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_45.add(char_literal61);

					pushFollow(FOLLOW_assign_in_for1705);
					assign62=assign();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_assign.add(assign62.getTree());
					}
					break;

				default :
					break loop12;
				}
			}

			// AST REWRITE
			// elements: assign
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 97:33: -> ( assign )+
			{
				if ( !(stream_assign.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_assign.hasNext() ) {
					adaptor.addChild(root_0, stream_assign.nextTree());
				}
				stream_assign.reset();

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "for1"


	public static class for2_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "for2"
	// /compiler_study/CShell/antlr/CShell.g:98:1: for2 : expr ;
	public final CShellParser.for2_return for2() throws RecognitionException {
		CShellParser.for2_return retval = new CShellParser.for2_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		ParserRuleReturnScope expr63 =null;


		try {
			// /compiler_study/CShell/antlr/CShell.g:98:5: ( expr )
			// /compiler_study/CShell/antlr/CShell.g:98:7: expr
			{
			root_0 = (CShellAST)adaptor.nil();


			pushFollow(FOLLOW_expr_in_for2717);
			expr63=expr();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) adaptor.addChild(root_0, expr63.getTree());

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "for2"


	public static class for3_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "for3"
	// /compiler_study/CShell/antlr/CShell.g:99:1: for3 : expr ( ',' expr )* -> ( expr )+ ;
	public final CShellParser.for3_return for3() throws RecognitionException {
		CShellParser.for3_return retval = new CShellParser.for3_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token char_literal65=null;
		ParserRuleReturnScope expr64 =null;
		ParserRuleReturnScope expr66 =null;

		CShellAST char_literal65_tree=null;
		RewriteRuleTokenStream stream_45=new RewriteRuleTokenStream(adaptor,"token 45");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

		try {
			// /compiler_study/CShell/antlr/CShell.g:99:5: ( expr ( ',' expr )* -> ( expr )+ )
			// /compiler_study/CShell/antlr/CShell.g:99:7: expr ( ',' expr )*
			{
			pushFollow(FOLLOW_expr_in_for3723);
			expr64=expr();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_expr.add(expr64.getTree());
			// /compiler_study/CShell/antlr/CShell.g:99:11: ( ',' expr )*
			loop13:
			while (true) {
				int alt13=2;
				int LA13_0 = input.LA(1);
				if ( (LA13_0==45) ) {
					alt13=1;
				}

				switch (alt13) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:99:12: ',' expr
					{
					char_literal65=(Token)match(input,45,FOLLOW_45_in_for3725); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_45.add(char_literal65);

					pushFollow(FOLLOW_expr_in_for3727);
					expr66=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr66.getTree());
					}
					break;

				default :
					break loop13;
				}
			}

			// AST REWRITE
			// elements: expr
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 99:23: -> ( expr )+
			{
				if ( !(stream_expr.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_expr.hasNext() ) {
					adaptor.addChild(root_0, stream_expr.nextTree());
				}
				stream_expr.reset();

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "for3"


	public static class array_statement_init_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "array_statement_init"
	// /compiler_study/CShell/antlr/CShell.g:101:1: array_statement_init : ID '=' '[' ( array_values )? ']' ';' -> ^( ARRAY ID ( array_values )? ) ;
	public final CShellParser.array_statement_init_return array_statement_init() throws RecognitionException {
		CShellParser.array_statement_init_return retval = new CShellParser.array_statement_init_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token ID67=null;
		Token char_literal68=null;
		Token char_literal69=null;
		Token char_literal71=null;
		Token char_literal72=null;
		ParserRuleReturnScope array_values70 =null;

		CShellAST ID67_tree=null;
		CShellAST char_literal68_tree=null;
		CShellAST char_literal69_tree=null;
		CShellAST char_literal71_tree=null;
		CShellAST char_literal72_tree=null;
		RewriteRuleTokenStream stream_49=new RewriteRuleTokenStream(adaptor,"token 49");
		RewriteRuleTokenStream stream_48=new RewriteRuleTokenStream(adaptor,"token 48");
		RewriteRuleTokenStream stream_47=new RewriteRuleTokenStream(adaptor,"token 47");
		RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
		RewriteRuleTokenStream stream_ASSIGN=new RewriteRuleTokenStream(adaptor,"token ASSIGN");
		RewriteRuleSubtreeStream stream_array_values=new RewriteRuleSubtreeStream(adaptor,"rule array_values");

		try {
			// /compiler_study/CShell/antlr/CShell.g:101:21: ( ID '=' '[' ( array_values )? ']' ';' -> ^( ARRAY ID ( array_values )? ) )
			// /compiler_study/CShell/antlr/CShell.g:102:7: ID '=' '[' ( array_values )? ']' ';'
			{
			ID67=(Token)match(input,ID,FOLLOW_ID_in_array_statement_init747); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ID.add(ID67);

			char_literal68=(Token)match(input,ASSIGN,FOLLOW_ASSIGN_in_array_statement_init749); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ASSIGN.add(char_literal68);

			char_literal69=(Token)match(input,48,FOLLOW_48_in_array_statement_init751); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_48.add(char_literal69);

			// /compiler_study/CShell/antlr/CShell.g:102:18: ( array_values )?
			int alt14=2;
			int LA14_0 = input.LA(1);
			if ( (LA14_0==CHAR||LA14_0==FLOAT||LA14_0==ID||(LA14_0 >= INT && LA14_0 <= LENGTH)||LA14_0==STRING||LA14_0==42||LA14_0==44||LA14_0==46) ) {
				alt14=1;
			}
			switch (alt14) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:102:18: array_values
					{
					pushFollow(FOLLOW_array_values_in_array_statement_init753);
					array_values70=array_values();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_array_values.add(array_values70.getTree());
					}
					break;

			}

			char_literal71=(Token)match(input,49,FOLLOW_49_in_array_statement_init756); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_49.add(char_literal71);

			char_literal72=(Token)match(input,47,FOLLOW_47_in_array_statement_init757); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_47.add(char_literal72);

			// AST REWRITE
			// elements: ID, array_values
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 103:7: -> ^( ARRAY ID ( array_values )? )
			{
				// /compiler_study/CShell/antlr/CShell.g:103:9: ^( ARRAY ID ( array_values )? )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(ARRAY, "ARRAY"), root_1);
				adaptor.addChild(root_1, stream_ID.nextNode());
				// /compiler_study/CShell/antlr/CShell.g:103:20: ( array_values )?
				if ( stream_array_values.hasNext() ) {
					adaptor.addChild(root_1, stream_array_values.nextTree());
				}
				stream_array_values.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "array_statement_init"


	public static class array_value_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "array_value"
	// /compiler_study/CShell/antlr/CShell.g:105:1: array_value : ( INT | FLOAT | CHAR | STRING | expr );
	public final CShellParser.array_value_return array_value() throws RecognitionException {
		CShellParser.array_value_return retval = new CShellParser.array_value_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token INT73=null;
		Token FLOAT74=null;
		Token CHAR75=null;
		Token STRING76=null;
		ParserRuleReturnScope expr77 =null;

		CShellAST INT73_tree=null;
		CShellAST FLOAT74_tree=null;
		CShellAST CHAR75_tree=null;
		CShellAST STRING76_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:105:12: ( INT | FLOAT | CHAR | STRING | expr )
			int alt15=5;
			switch ( input.LA(1) ) {
			case INT:
				{
				int LA15_1 = input.LA(2);
				if ( (synpred23_CShell()) ) {
					alt15=1;
				}
				else if ( (true) ) {
					alt15=5;
				}

				}
				break;
			case FLOAT:
				{
				int LA15_2 = input.LA(2);
				if ( (synpred24_CShell()) ) {
					alt15=2;
				}
				else if ( (true) ) {
					alt15=5;
				}

				}
				break;
			case CHAR:
				{
				int LA15_3 = input.LA(2);
				if ( (synpred25_CShell()) ) {
					alt15=3;
				}
				else if ( (true) ) {
					alt15=5;
				}

				}
				break;
			case STRING:
				{
				int LA15_4 = input.LA(2);
				if ( (synpred26_CShell()) ) {
					alt15=4;
				}
				else if ( (true) ) {
					alt15=5;
				}

				}
				break;
			case ID:
			case LENGTH:
			case 42:
			case 44:
			case 46:
				{
				alt15=5;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 15, 0, input);
				throw nvae;
			}
			switch (alt15) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:105:13: INT
					{
					root_0 = (CShellAST)adaptor.nil();


					INT73=(Token)match(input,INT,FOLLOW_INT_in_array_value780); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					INT73_tree = (CShellAST)adaptor.create(INT73);
					adaptor.addChild(root_0, INT73_tree);
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:105:17: FLOAT
					{
					root_0 = (CShellAST)adaptor.nil();


					FLOAT74=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_array_value782); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					FLOAT74_tree = (CShellAST)adaptor.create(FLOAT74);
					adaptor.addChild(root_0, FLOAT74_tree);
					}

					}
					break;
				case 3 :
					// /compiler_study/CShell/antlr/CShell.g:105:23: CHAR
					{
					root_0 = (CShellAST)adaptor.nil();


					CHAR75=(Token)match(input,CHAR,FOLLOW_CHAR_in_array_value784); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					CHAR75_tree = (CShellAST)adaptor.create(CHAR75);
					adaptor.addChild(root_0, CHAR75_tree);
					}

					}
					break;
				case 4 :
					// /compiler_study/CShell/antlr/CShell.g:105:28: STRING
					{
					root_0 = (CShellAST)adaptor.nil();


					STRING76=(Token)match(input,STRING,FOLLOW_STRING_in_array_value786); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					STRING76_tree = (CShellAST)adaptor.create(STRING76);
					adaptor.addChild(root_0, STRING76_tree);
					}

					}
					break;
				case 5 :
					// /compiler_study/CShell/antlr/CShell.g:105:35: expr
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_expr_in_array_value788);
					expr77=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, expr77.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "array_value"


	public static class array_values_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "array_values"
	// /compiler_study/CShell/antlr/CShell.g:106:1: array_values : array_value ( ',' array_value )* -> ( array_value )+ ;
	public final CShellParser.array_values_return array_values() throws RecognitionException {
		CShellParser.array_values_return retval = new CShellParser.array_values_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token char_literal79=null;
		ParserRuleReturnScope array_value78 =null;
		ParserRuleReturnScope array_value80 =null;

		CShellAST char_literal79_tree=null;
		RewriteRuleTokenStream stream_45=new RewriteRuleTokenStream(adaptor,"token 45");
		RewriteRuleSubtreeStream stream_array_value=new RewriteRuleSubtreeStream(adaptor,"rule array_value");

		try {
			// /compiler_study/CShell/antlr/CShell.g:106:13: ( array_value ( ',' array_value )* -> ( array_value )+ )
			// /compiler_study/CShell/antlr/CShell.g:106:14: array_value ( ',' array_value )*
			{
			pushFollow(FOLLOW_array_value_in_array_values793);
			array_value78=array_value();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_array_value.add(array_value78.getTree());
			// /compiler_study/CShell/antlr/CShell.g:106:25: ( ',' array_value )*
			loop16:
			while (true) {
				int alt16=2;
				int LA16_0 = input.LA(1);
				if ( (LA16_0==45) ) {
					alt16=1;
				}

				switch (alt16) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:106:26: ',' array_value
					{
					char_literal79=(Token)match(input,45,FOLLOW_45_in_array_values795); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_45.add(char_literal79);

					pushFollow(FOLLOW_array_value_in_array_values797);
					array_value80=array_value();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_array_value.add(array_value80.getTree());
					}
					break;

				default :
					break loop16;
				}
			}

			// AST REWRITE
			// elements: array_value
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 106:44: -> ( array_value )+
			{
				if ( !(stream_array_value.hasNext()) ) {
					throw new RewriteEarlyExitException();
				}
				while ( stream_array_value.hasNext() ) {
					adaptor.addChild(root_0, stream_array_value.nextTree());
				}
				stream_array_value.reset();

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "array_values"


	public static class array_element_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "array_element"
	// /compiler_study/CShell/antlr/CShell.g:109:1: array_element : a= ID '[' b= expr ']' -> ^( ARRAY_ELEMENT $a $b) ;
	public final CShellParser.array_element_return array_element() throws RecognitionException {
		CShellParser.array_element_return retval = new CShellParser.array_element_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token a=null;
		Token char_literal81=null;
		Token char_literal82=null;
		ParserRuleReturnScope b =null;

		CShellAST a_tree=null;
		CShellAST char_literal81_tree=null;
		CShellAST char_literal82_tree=null;
		RewriteRuleTokenStream stream_49=new RewriteRuleTokenStream(adaptor,"token 49");
		RewriteRuleTokenStream stream_48=new RewriteRuleTokenStream(adaptor,"token 48");
		RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

		try {
			// /compiler_study/CShell/antlr/CShell.g:109:14: (a= ID '[' b= expr ']' -> ^( ARRAY_ELEMENT $a $b) )
			// /compiler_study/CShell/antlr/CShell.g:109:15: a= ID '[' b= expr ']'
			{
			a=(Token)match(input,ID,FOLLOW_ID_in_array_element815); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ID.add(a);

			char_literal81=(Token)match(input,48,FOLLOW_48_in_array_element816); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_48.add(char_literal81);

			pushFollow(FOLLOW_expr_in_array_element822);
			b=expr();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_expr.add(b.getTree());
			char_literal82=(Token)match(input,49,FOLLOW_49_in_array_element824); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_49.add(char_literal82);

			// AST REWRITE
			// elements: b, a
			// token labels: a
			// rule labels: retval, b
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleTokenStream stream_a=new RewriteRuleTokenStream(adaptor,"token a",a);
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);
			RewriteRuleSubtreeStream stream_b=new RewriteRuleSubtreeStream(adaptor,"rule b",b!=null?b.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 109:38: -> ^( ARRAY_ELEMENT $a $b)
			{
				// /compiler_study/CShell/antlr/CShell.g:109:40: ^( ARRAY_ELEMENT $a $b)
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(ARRAY_ELEMENT, "ARRAY_ELEMENT"), root_1);
				adaptor.addChild(root_1, stream_a.nextNode());
				adaptor.addChild(root_1, stream_b.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "array_element"


	public static class assign_id_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "assign_id"
	// /compiler_study/CShell/antlr/CShell.g:111:1: assign_id : ( ID ^| array_element );
	public final CShellParser.assign_id_return assign_id() throws RecognitionException {
		CShellParser.assign_id_return retval = new CShellParser.assign_id_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token ID83=null;
		ParserRuleReturnScope array_element84 =null;

		CShellAST ID83_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:111:10: ( ID ^| array_element )
			int alt17=2;
			int LA17_0 = input.LA(1);
			if ( (LA17_0==ID) ) {
				int LA17_1 = input.LA(2);
				if ( (LA17_1==48) ) {
					alt17=2;
				}
				else if ( (LA17_1==ASSIGN||LA17_1==43) ) {
					alt17=1;
				}

				else {
					if (state.backtracking>0) {state.failed=true; return retval;}
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 17, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 17, 0, input);
				throw nvae;
			}

			switch (alt17) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:111:11: ID ^
					{
					root_0 = (CShellAST)adaptor.nil();


					ID83=(Token)match(input,ID,FOLLOW_ID_in_assign_id841); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					ID83_tree = (CShellAST)adaptor.create(ID83);
					root_0 = (CShellAST)adaptor.becomeRoot(ID83_tree, root_0);
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:111:15: array_element
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_array_element_in_assign_id844);
					array_element84=array_element();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, array_element84.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "assign_id"


	public static class assign_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "assign"
	// /compiler_study/CShell/antlr/CShell.g:113:1: assign : ( assign_id '=' expr ) -> ^( '=' assign_id expr ) ;
	public final CShellParser.assign_return assign() throws RecognitionException {
		CShellParser.assign_return retval = new CShellParser.assign_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token char_literal86=null;
		ParserRuleReturnScope assign_id85 =null;
		ParserRuleReturnScope expr87 =null;

		CShellAST char_literal86_tree=null;
		RewriteRuleTokenStream stream_ASSIGN=new RewriteRuleTokenStream(adaptor,"token ASSIGN");
		RewriteRuleSubtreeStream stream_assign_id=new RewriteRuleSubtreeStream(adaptor,"rule assign_id");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

		try {
			// /compiler_study/CShell/antlr/CShell.g:113:7: ( ( assign_id '=' expr ) -> ^( '=' assign_id expr ) )
			// /compiler_study/CShell/antlr/CShell.g:113:9: ( assign_id '=' expr )
			{
			// /compiler_study/CShell/antlr/CShell.g:113:9: ( assign_id '=' expr )
			// /compiler_study/CShell/antlr/CShell.g:113:10: assign_id '=' expr
			{
			pushFollow(FOLLOW_assign_id_in_assign853);
			assign_id85=assign_id();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_assign_id.add(assign_id85.getTree());
			char_literal86=(Token)match(input,ASSIGN,FOLLOW_ASSIGN_in_assign855); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_ASSIGN.add(char_literal86);

			pushFollow(FOLLOW_expr_in_assign857);
			expr87=expr();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_expr.add(expr87.getTree());
			}

			// AST REWRITE
			// elements: assign_id, expr, ASSIGN
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 113:29: -> ^( '=' assign_id expr )
			{
				// /compiler_study/CShell/antlr/CShell.g:113:32: ^( '=' assign_id expr )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot(stream_ASSIGN.nextNode(), root_1);
				adaptor.addChild(root_1, stream_assign_id.nextTree());
				adaptor.addChild(root_1, stream_expr.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "assign"


	public static class slist_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "slist"
	// /compiler_study/CShell/antlr/CShell.g:116:1: slist : ( NL )* '{' ( NL )* ( statement )* ( NL )* '}' ( NL )* -> ^( BLOCK ( statement )* ) ;
	public final CShellParser.slist_return slist() throws RecognitionException {
		CShellParser.slist_return retval = new CShellParser.slist_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token NL88=null;
		Token char_literal89=null;
		Token NL90=null;
		Token NL92=null;
		Token char_literal93=null;
		Token NL94=null;
		ParserRuleReturnScope statement91 =null;

		CShellAST NL88_tree=null;
		CShellAST char_literal89_tree=null;
		CShellAST NL90_tree=null;
		CShellAST NL92_tree=null;
		CShellAST char_literal93_tree=null;
		CShellAST NL94_tree=null;
		RewriteRuleTokenStream stream_NL=new RewriteRuleTokenStream(adaptor,"token NL");
		RewriteRuleTokenStream stream_51=new RewriteRuleTokenStream(adaptor,"token 51");
		RewriteRuleTokenStream stream_52=new RewriteRuleTokenStream(adaptor,"token 52");
		RewriteRuleSubtreeStream stream_statement=new RewriteRuleSubtreeStream(adaptor,"rule statement");

		try {
			// /compiler_study/CShell/antlr/CShell.g:117:2: ( ( NL )* '{' ( NL )* ( statement )* ( NL )* '}' ( NL )* -> ^( BLOCK ( statement )* ) )
			// /compiler_study/CShell/antlr/CShell.g:117:4: ( NL )* '{' ( NL )* ( statement )* ( NL )* '}' ( NL )*
			{
			// /compiler_study/CShell/antlr/CShell.g:117:4: ( NL )*
			loop18:
			while (true) {
				int alt18=2;
				int LA18_0 = input.LA(1);
				if ( (LA18_0==NL) ) {
					alt18=1;
				}

				switch (alt18) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:117:4: NL
					{
					NL88=(Token)match(input,NL,FOLLOW_NL_in_slist880); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_NL.add(NL88);

					}
					break;

				default :
					break loop18;
				}
			}

			char_literal89=(Token)match(input,51,FOLLOW_51_in_slist882); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_51.add(char_literal89);

			// /compiler_study/CShell/antlr/CShell.g:117:11: ( NL )*
			loop19:
			while (true) {
				int alt19=2;
				int LA19_0 = input.LA(1);
				if ( (LA19_0==NL) ) {
					int LA19_2 = input.LA(2);
					if ( (synpred30_CShell()) ) {
						alt19=1;
					}

				}

				switch (alt19) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:117:11: NL
					{
					NL90=(Token)match(input,NL,FOLLOW_NL_in_slist884); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_NL.add(NL90);

					}
					break;

				default :
					break loop19;
				}
			}

			// /compiler_study/CShell/antlr/CShell.g:117:15: ( statement )*
			loop20:
			while (true) {
				int alt20=2;
				int LA20_0 = input.LA(1);
				if ( (LA20_0==NL) ) {
					int LA20_1 = input.LA(2);
					if ( (synpred31_CShell()) ) {
						alt20=1;
					}

				}
				else if ( (LA20_0==FOR||(LA20_0 >= ID && LA20_0 <= IF)||(LA20_0 >= PRINT && LA20_0 <= RETURN)||LA20_0==44||LA20_0==46) ) {
					alt20=1;
				}

				switch (alt20) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:117:16: statement
					{
					pushFollow(FOLLOW_statement_in_slist888);
					statement91=statement();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_statement.add(statement91.getTree());
					}
					break;

				default :
					break loop20;
				}
			}

			// /compiler_study/CShell/antlr/CShell.g:117:28: ( NL )*
			loop21:
			while (true) {
				int alt21=2;
				int LA21_0 = input.LA(1);
				if ( (LA21_0==NL) ) {
					alt21=1;
				}

				switch (alt21) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:117:28: NL
					{
					NL92=(Token)match(input,NL,FOLLOW_NL_in_slist892); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_NL.add(NL92);

					}
					break;

				default :
					break loop21;
				}
			}

			char_literal93=(Token)match(input,52,FOLLOW_52_in_slist895); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_52.add(char_literal93);

			// /compiler_study/CShell/antlr/CShell.g:117:35: ( NL )*
			loop22:
			while (true) {
				int alt22=2;
				int LA22_0 = input.LA(1);
				if ( (LA22_0==NL) ) {
					int LA22_2 = input.LA(2);
					if ( (synpred33_CShell()) ) {
						alt22=1;
					}

				}

				switch (alt22) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:117:35: NL
					{
					NL94=(Token)match(input,NL,FOLLOW_NL_in_slist896); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_NL.add(NL94);

					}
					break;

				default :
					break loop22;
				}
			}

			// AST REWRITE
			// elements: statement
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 117:40: -> ^( BLOCK ( statement )* )
			{
				// /compiler_study/CShell/antlr/CShell.g:117:43: ^( BLOCK ( statement )* )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(BLOCK, "BLOCK"), root_1);
				// /compiler_study/CShell/antlr/CShell.g:117:51: ( statement )*
				while ( stream_statement.hasNext() ) {
					adaptor.addChild(root_1, stream_statement.nextTree());
				}
				stream_statement.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "slist"


	public static class length_fun_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "length_fun"
	// /compiler_study/CShell/antlr/CShell.g:120:1: length_fun : 'length' '(' assign_id ')' -> ^( 'length' assign_id ) ;
	public final CShellParser.length_fun_return length_fun() throws RecognitionException {
		CShellParser.length_fun_return retval = new CShellParser.length_fun_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal95=null;
		Token char_literal96=null;
		Token char_literal98=null;
		ParserRuleReturnScope assign_id97 =null;

		CShellAST string_literal95_tree=null;
		CShellAST char_literal96_tree=null;
		CShellAST char_literal98_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleTokenStream stream_LENGTH=new RewriteRuleTokenStream(adaptor,"token LENGTH");
		RewriteRuleSubtreeStream stream_assign_id=new RewriteRuleSubtreeStream(adaptor,"rule assign_id");

		try {
			// /compiler_study/CShell/antlr/CShell.g:120:11: ( 'length' '(' assign_id ')' -> ^( 'length' assign_id ) )
			// /compiler_study/CShell/antlr/CShell.g:120:12: 'length' '(' assign_id ')'
			{
			string_literal95=(Token)match(input,LENGTH,FOLLOW_LENGTH_in_length_fun920); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_LENGTH.add(string_literal95);

			char_literal96=(Token)match(input,42,FOLLOW_42_in_length_fun922); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_42.add(char_literal96);

			pushFollow(FOLLOW_assign_id_in_length_fun924);
			assign_id97=assign_id();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) stream_assign_id.add(assign_id97.getTree());
			char_literal98=(Token)match(input,43,FOLLOW_43_in_length_fun926); if (state.failed) return retval; 
			if ( state.backtracking==0 ) stream_43.add(char_literal98);

			// AST REWRITE
			// elements: LENGTH, assign_id
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			if ( state.backtracking==0 ) {
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (CShellAST)adaptor.nil();
			// 120:44: -> ^( 'length' assign_id )
			{
				// /compiler_study/CShell/antlr/CShell.g:120:47: ^( 'length' assign_id )
				{
				CShellAST root_1 = (CShellAST)adaptor.nil();
				root_1 = (CShellAST)adaptor.becomeRoot(stream_LENGTH.nextNode(), root_1);
				adaptor.addChild(root_1, stream_assign_id.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "length_fun"


	public static class expr_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "expr"
	// /compiler_study/CShell/antlr/CShell.g:121:1: expr : ( inc_dec | assign | ( addexpr ( ( '==' | '<' | '>' ) ^ addexpr )? ) | length_fun );
	public final CShellParser.expr_return expr() throws RecognitionException {
		CShellParser.expr_return retval = new CShellParser.expr_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token set102=null;
		ParserRuleReturnScope inc_dec99 =null;
		ParserRuleReturnScope assign100 =null;
		ParserRuleReturnScope addexpr101 =null;
		ParserRuleReturnScope addexpr103 =null;
		ParserRuleReturnScope length_fun104 =null;

		CShellAST set102_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:121:5: ( inc_dec | assign | ( addexpr ( ( '==' | '<' | '>' ) ^ addexpr )? ) | length_fun )
			int alt24=4;
			switch ( input.LA(1) ) {
			case 44:
			case 46:
				{
				alt24=1;
				}
				break;
			case ID:
				{
				int LA24_3 = input.LA(2);
				if ( (synpred34_CShell()) ) {
					alt24=1;
				}
				else if ( (synpred35_CShell()) ) {
					alt24=2;
				}
				else if ( (synpred39_CShell()) ) {
					alt24=3;
				}

				else {
					if (state.backtracking>0) {state.failed=true; return retval;}
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 24, 3, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

				}
				break;
			case CHAR:
			case FLOAT:
			case INT:
			case STRING:
			case 42:
				{
				alt24=3;
				}
				break;
			case LENGTH:
				{
				alt24=4;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 24, 0, input);
				throw nvae;
			}
			switch (alt24) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:121:7: inc_dec
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_inc_dec_in_expr946);
					inc_dec99=inc_dec();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, inc_dec99.getTree());

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:121:15: assign
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_assign_in_expr948);
					assign100=assign();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, assign100.getTree());

					}
					break;
				case 3 :
					// /compiler_study/CShell/antlr/CShell.g:121:22: ( addexpr ( ( '==' | '<' | '>' ) ^ addexpr )? )
					{
					root_0 = (CShellAST)adaptor.nil();


					// /compiler_study/CShell/antlr/CShell.g:121:22: ( addexpr ( ( '==' | '<' | '>' ) ^ addexpr )? )
					// /compiler_study/CShell/antlr/CShell.g:121:23: addexpr ( ( '==' | '<' | '>' ) ^ addexpr )?
					{
					pushFollow(FOLLOW_addexpr_in_expr951);
					addexpr101=addexpr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, addexpr101.getTree());

					// /compiler_study/CShell/antlr/CShell.g:121:31: ( ( '==' | '<' | '>' ) ^ addexpr )?
					int alt23=2;
					int LA23_0 = input.LA(1);
					if ( (LA23_0==EQ||LA23_0==GT||LA23_0==LT) ) {
						alt23=1;
					}
					switch (alt23) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:121:32: ( '==' | '<' | '>' ) ^ addexpr
							{
							set102=input.LT(1);
							set102=input.LT(1);
							if ( input.LA(1)==EQ||input.LA(1)==GT||input.LA(1)==LT ) {
								input.consume();
								if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(set102), root_0);
								state.errorRecovery=false;
								state.failed=false;
							}
							else {
								if (state.backtracking>0) {state.failed=true; return retval;}
								MismatchedSetException mse = new MismatchedSetException(null,input);
								throw mse;
							}
							pushFollow(FOLLOW_addexpr_in_expr963);
							addexpr103=addexpr();
							state._fsp--;
							if (state.failed) return retval;
							if ( state.backtracking==0 ) adaptor.addChild(root_0, addexpr103.getTree());

							}
							break;

					}

					}

					}
					break;
				case 4 :
					// /compiler_study/CShell/antlr/CShell.g:122:10: length_fun
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_length_fun_in_expr977);
					length_fun104=length_fun();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, length_fun104.getTree());

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "expr"


	public static class inc_dec_id_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "inc_dec_id"
	// /compiler_study/CShell/antlr/CShell.g:123:1: inc_dec_id : ( ID ^| array_element ^);
	public final CShellParser.inc_dec_id_return inc_dec_id() throws RecognitionException {
		CShellParser.inc_dec_id_return retval = new CShellParser.inc_dec_id_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token ID105=null;
		ParserRuleReturnScope array_element106 =null;

		CShellAST ID105_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:123:11: ( ID ^| array_element ^)
			int alt25=2;
			int LA25_0 = input.LA(1);
			if ( (LA25_0==ID) ) {
				int LA25_1 = input.LA(2);
				if ( (LA25_1==48) ) {
					alt25=2;
				}
				else if ( (LA25_1==EOF||(LA25_1 >= 43 && LA25_1 <= 47)||LA25_1==49) ) {
					alt25=1;
				}

				else {
					if (state.backtracking>0) {state.failed=true; return retval;}
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 25, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 25, 0, input);
				throw nvae;
			}

			switch (alt25) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:123:12: ID ^
					{
					root_0 = (CShellAST)adaptor.nil();


					ID105=(Token)match(input,ID,FOLLOW_ID_in_inc_dec_id983); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					ID105_tree = (CShellAST)adaptor.create(ID105);
					root_0 = (CShellAST)adaptor.becomeRoot(ID105_tree, root_0);
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:123:16: array_element ^
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_array_element_in_inc_dec_id986);
					array_element106=array_element();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot(array_element106.getTree(), root_0);
					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "inc_dec_id"


	public static class inc_dec_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "inc_dec"
	// /compiler_study/CShell/antlr/CShell.g:124:1: inc_dec : ( ( '++' inc_dec_id ) -> ^( PREV INC inc_dec_id ) | ( '--' inc_dec_id ) -> ^( PREV DEC inc_dec_id ) | ( inc_dec_id '++' ) -> ^( SUFFIX INC inc_dec_id ) | ( inc_dec_id '--' ) -> ^( SUFFIX DEC inc_dec_id ) );
	public final CShellParser.inc_dec_return inc_dec() throws RecognitionException {
		CShellParser.inc_dec_return retval = new CShellParser.inc_dec_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token string_literal107=null;
		Token string_literal109=null;
		Token string_literal112=null;
		Token string_literal114=null;
		ParserRuleReturnScope inc_dec_id108 =null;
		ParserRuleReturnScope inc_dec_id110 =null;
		ParserRuleReturnScope inc_dec_id111 =null;
		ParserRuleReturnScope inc_dec_id113 =null;

		CShellAST string_literal107_tree=null;
		CShellAST string_literal109_tree=null;
		CShellAST string_literal112_tree=null;
		CShellAST string_literal114_tree=null;
		RewriteRuleTokenStream stream_44=new RewriteRuleTokenStream(adaptor,"token 44");
		RewriteRuleTokenStream stream_46=new RewriteRuleTokenStream(adaptor,"token 46");
		RewriteRuleSubtreeStream stream_inc_dec_id=new RewriteRuleSubtreeStream(adaptor,"rule inc_dec_id");

		try {
			// /compiler_study/CShell/antlr/CShell.g:124:8: ( ( '++' inc_dec_id ) -> ^( PREV INC inc_dec_id ) | ( '--' inc_dec_id ) -> ^( PREV DEC inc_dec_id ) | ( inc_dec_id '++' ) -> ^( SUFFIX INC inc_dec_id ) | ( inc_dec_id '--' ) -> ^( SUFFIX DEC inc_dec_id ) )
			int alt26=4;
			switch ( input.LA(1) ) {
			case 44:
				{
				alt26=1;
				}
				break;
			case 46:
				{
				alt26=2;
				}
				break;
			case ID:
				{
				int LA26_3 = input.LA(2);
				if ( (synpred43_CShell()) ) {
					alt26=3;
				}
				else if ( (true) ) {
					alt26=4;
				}

				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 26, 0, input);
				throw nvae;
			}
			switch (alt26) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:124:10: ( '++' inc_dec_id )
					{
					// /compiler_study/CShell/antlr/CShell.g:124:10: ( '++' inc_dec_id )
					// /compiler_study/CShell/antlr/CShell.g:124:11: '++' inc_dec_id
					{
					string_literal107=(Token)match(input,44,FOLLOW_44_in_inc_dec994); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_44.add(string_literal107);

					pushFollow(FOLLOW_inc_dec_id_in_inc_dec997);
					inc_dec_id108=inc_dec_id();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_inc_dec_id.add(inc_dec_id108.getTree());
					}

					// AST REWRITE
					// elements: inc_dec_id
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 124:28: -> ^( PREV INC inc_dec_id )
					{
						// /compiler_study/CShell/antlr/CShell.g:124:30: ^( PREV INC inc_dec_id )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(PREV, "PREV"), root_1);
						adaptor.addChild(root_1, (CShellAST)adaptor.create(INC, "INC"));
						adaptor.addChild(root_1, stream_inc_dec_id.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:125:10: ( '--' inc_dec_id )
					{
					// /compiler_study/CShell/antlr/CShell.g:125:10: ( '--' inc_dec_id )
					// /compiler_study/CShell/antlr/CShell.g:125:11: '--' inc_dec_id
					{
					string_literal109=(Token)match(input,46,FOLLOW_46_in_inc_dec1018); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_46.add(string_literal109);

					pushFollow(FOLLOW_inc_dec_id_in_inc_dec1019);
					inc_dec_id110=inc_dec_id();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_inc_dec_id.add(inc_dec_id110.getTree());
					}

					// AST REWRITE
					// elements: inc_dec_id
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 125:26: -> ^( PREV DEC inc_dec_id )
					{
						// /compiler_study/CShell/antlr/CShell.g:125:28: ^( PREV DEC inc_dec_id )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(PREV, "PREV"), root_1);
						adaptor.addChild(root_1, (CShellAST)adaptor.create(DEC, "DEC"));
						adaptor.addChild(root_1, stream_inc_dec_id.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 3 :
					// /compiler_study/CShell/antlr/CShell.g:126:10: ( inc_dec_id '++' )
					{
					// /compiler_study/CShell/antlr/CShell.g:126:10: ( inc_dec_id '++' )
					// /compiler_study/CShell/antlr/CShell.g:126:11: inc_dec_id '++'
					{
					pushFollow(FOLLOW_inc_dec_id_in_inc_dec1040);
					inc_dec_id111=inc_dec_id();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_inc_dec_id.add(inc_dec_id111.getTree());
					string_literal112=(Token)match(input,44,FOLLOW_44_in_inc_dec1041); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_44.add(string_literal112);

					}

					// AST REWRITE
					// elements: inc_dec_id
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 126:26: -> ^( SUFFIX INC inc_dec_id )
					{
						// /compiler_study/CShell/antlr/CShell.g:126:28: ^( SUFFIX INC inc_dec_id )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(SUFFIX, "SUFFIX"), root_1);
						adaptor.addChild(root_1, (CShellAST)adaptor.create(INC, "INC"));
						adaptor.addChild(root_1, stream_inc_dec_id.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;
				case 4 :
					// /compiler_study/CShell/antlr/CShell.g:127:10: ( inc_dec_id '--' )
					{
					// /compiler_study/CShell/antlr/CShell.g:127:10: ( inc_dec_id '--' )
					// /compiler_study/CShell/antlr/CShell.g:127:11: inc_dec_id '--'
					{
					pushFollow(FOLLOW_inc_dec_id_in_inc_dec1062);
					inc_dec_id113=inc_dec_id();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_inc_dec_id.add(inc_dec_id113.getTree());
					string_literal114=(Token)match(input,46,FOLLOW_46_in_inc_dec1063); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_46.add(string_literal114);

					}

					// AST REWRITE
					// elements: inc_dec_id
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 127:26: -> ^( SUFFIX DEC inc_dec_id )
					{
						// /compiler_study/CShell/antlr/CShell.g:127:28: ^( SUFFIX DEC inc_dec_id )
						{
						CShellAST root_1 = (CShellAST)adaptor.nil();
						root_1 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(SUFFIX, "SUFFIX"), root_1);
						adaptor.addChild(root_1, (CShellAST)adaptor.create(DEC, "DEC"));
						adaptor.addChild(root_1, stream_inc_dec_id.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;
					}

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "inc_dec"


	public static class addexpr_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "addexpr"
	// /compiler_study/CShell/antlr/CShell.g:129:1: addexpr : mulexpr ( ( '+' | '-' ) ^ mulexpr )* ;
	public final CShellParser.addexpr_return addexpr() throws RecognitionException {
		CShellParser.addexpr_return retval = new CShellParser.addexpr_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token set116=null;
		ParserRuleReturnScope mulexpr115 =null;
		ParserRuleReturnScope mulexpr117 =null;

		CShellAST set116_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:130:2: ( mulexpr ( ( '+' | '-' ) ^ mulexpr )* )
			// /compiler_study/CShell/antlr/CShell.g:130:5: mulexpr ( ( '+' | '-' ) ^ mulexpr )*
			{
			root_0 = (CShellAST)adaptor.nil();


			pushFollow(FOLLOW_mulexpr_in_addexpr1084);
			mulexpr115=mulexpr();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) adaptor.addChild(root_0, mulexpr115.getTree());

			// /compiler_study/CShell/antlr/CShell.g:130:13: ( ( '+' | '-' ) ^ mulexpr )*
			loop27:
			while (true) {
				int alt27=2;
				int LA27_0 = input.LA(1);
				if ( (LA27_0==ADD||LA27_0==SUB) ) {
					alt27=1;
				}

				switch (alt27) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:130:14: ( '+' | '-' ) ^ mulexpr
					{
					set116=input.LT(1);
					set116=input.LT(1);
					if ( input.LA(1)==ADD||input.LA(1)==SUB ) {
						input.consume();
						if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(set116), root_0);
						state.errorRecovery=false;
						state.failed=false;
					}
					else {
						if (state.backtracking>0) {state.failed=true; return retval;}
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					pushFollow(FOLLOW_mulexpr_in_addexpr1094);
					mulexpr117=mulexpr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, mulexpr117.getTree());

					}
					break;

				default :
					break loop27;
				}
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "addexpr"


	public static class mulexpr_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "mulexpr"
	// /compiler_study/CShell/antlr/CShell.g:133:1: mulexpr : atom ( ( '*' | '/' ) ^ atom )* ;
	public final CShellParser.mulexpr_return mulexpr() throws RecognitionException {
		CShellParser.mulexpr_return retval = new CShellParser.mulexpr_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token set119=null;
		ParserRuleReturnScope atom118 =null;
		ParserRuleReturnScope atom120 =null;

		CShellAST set119_tree=null;

		try {
			// /compiler_study/CShell/antlr/CShell.g:134:2: ( atom ( ( '*' | '/' ) ^ atom )* )
			// /compiler_study/CShell/antlr/CShell.g:134:4: atom ( ( '*' | '/' ) ^ atom )*
			{
			root_0 = (CShellAST)adaptor.nil();


			pushFollow(FOLLOW_atom_in_mulexpr1111);
			atom118=atom();
			state._fsp--;
			if (state.failed) return retval;
			if ( state.backtracking==0 ) adaptor.addChild(root_0, atom118.getTree());

			// /compiler_study/CShell/antlr/CShell.g:134:9: ( ( '*' | '/' ) ^ atom )*
			loop28:
			while (true) {
				int alt28=2;
				int LA28_0 = input.LA(1);
				if ( (LA28_0==DIV||LA28_0==MUL) ) {
					alt28=1;
				}

				switch (alt28) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:134:10: ( '*' | '/' ) ^ atom
					{
					set119=input.LT(1);
					set119=input.LT(1);
					if ( input.LA(1)==DIV||input.LA(1)==MUL ) {
						input.consume();
						if ( state.backtracking==0 ) root_0 = (CShellAST)adaptor.becomeRoot((CShellAST)adaptor.create(set119), root_0);
						state.errorRecovery=false;
						state.failed=false;
					}
					else {
						if (state.backtracking>0) {state.failed=true; return retval;}
						MismatchedSetException mse = new MismatchedSetException(null,input);
						throw mse;
					}
					pushFollow(FOLLOW_atom_in_mulexpr1121);
					atom120=atom();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, atom120.getTree());

					}
					break;

				default :
					break loop28;
				}
			}

			}

			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "mulexpr"


	public static class atom_return extends ParserRuleReturnScope {
		CShellAST tree;
		@Override
		public CShellAST getTree() { return tree; }
	};


	// $ANTLR start "atom"
	// /compiler_study/CShell/antlr/CShell.g:137:1: atom : ( INT | CHAR | FLOAT | STRING | array_element | ID | call | '(' expr ')' -> expr );
	public final CShellParser.atom_return atom() throws RecognitionException {
		CShellParser.atom_return retval = new CShellParser.atom_return();
		retval.start = input.LT(1);

		CShellAST root_0 = null;

		Token INT121=null;
		Token CHAR122=null;
		Token FLOAT123=null;
		Token STRING124=null;
		Token ID126=null;
		Token char_literal128=null;
		Token char_literal130=null;
		ParserRuleReturnScope array_element125 =null;
		ParserRuleReturnScope call127 =null;
		ParserRuleReturnScope expr129 =null;

		CShellAST INT121_tree=null;
		CShellAST CHAR122_tree=null;
		CShellAST FLOAT123_tree=null;
		CShellAST STRING124_tree=null;
		CShellAST ID126_tree=null;
		CShellAST char_literal128_tree=null;
		CShellAST char_literal130_tree=null;
		RewriteRuleTokenStream stream_43=new RewriteRuleTokenStream(adaptor,"token 43");
		RewriteRuleTokenStream stream_42=new RewriteRuleTokenStream(adaptor,"token 42");
		RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

		try {
			// /compiler_study/CShell/antlr/CShell.g:138:2: ( INT | CHAR | FLOAT | STRING | array_element | ID | call | '(' expr ')' -> expr )
			int alt29=8;
			switch ( input.LA(1) ) {
			case INT:
				{
				alt29=1;
				}
				break;
			case CHAR:
				{
				alt29=2;
				}
				break;
			case FLOAT:
				{
				alt29=3;
				}
				break;
			case STRING:
				{
				alt29=4;
				}
				break;
			case ID:
				{
				switch ( input.LA(2) ) {
				case 48:
					{
					alt29=5;
					}
					break;
				case 42:
					{
					alt29=7;
					}
					break;
				case EOF:
				case ADD:
				case DIV:
				case EQ:
				case GT:
				case LT:
				case MUL:
				case SUB:
				case 43:
				case 45:
				case 47:
				case 49:
					{
					alt29=6;
					}
					break;
				default:
					if (state.backtracking>0) {state.failed=true; return retval;}
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 29, 5, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}
				}
				break;
			case 42:
				{
				alt29=8;
				}
				break;
			default:
				if (state.backtracking>0) {state.failed=true; return retval;}
				NoViableAltException nvae =
					new NoViableAltException("", 29, 0, input);
				throw nvae;
			}
			switch (alt29) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:138:4: INT
					{
					root_0 = (CShellAST)adaptor.nil();


					INT121=(Token)match(input,INT,FOLLOW_INT_in_atom1137); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					INT121_tree = (CShellAST)adaptor.create(INT121);
					adaptor.addChild(root_0, INT121_tree);
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:139:4: CHAR
					{
					root_0 = (CShellAST)adaptor.nil();


					CHAR122=(Token)match(input,CHAR,FOLLOW_CHAR_in_atom1148); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					CHAR122_tree = (CShellAST)adaptor.create(CHAR122);
					adaptor.addChild(root_0, CHAR122_tree);
					}

					}
					break;
				case 3 :
					// /compiler_study/CShell/antlr/CShell.g:140:4: FLOAT
					{
					root_0 = (CShellAST)adaptor.nil();


					FLOAT123=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_atom1158); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					FLOAT123_tree = (CShellAST)adaptor.create(FLOAT123);
					adaptor.addChild(root_0, FLOAT123_tree);
					}

					}
					break;
				case 4 :
					// /compiler_study/CShell/antlr/CShell.g:141:4: STRING
					{
					root_0 = (CShellAST)adaptor.nil();


					STRING124=(Token)match(input,STRING,FOLLOW_STRING_in_atom1168); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					STRING124_tree = (CShellAST)adaptor.create(STRING124);
					adaptor.addChild(root_0, STRING124_tree);
					}

					}
					break;
				case 5 :
					// /compiler_study/CShell/antlr/CShell.g:142:6: array_element
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_array_element_in_atom1176);
					array_element125=array_element();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, array_element125.getTree());

					}
					break;
				case 6 :
					// /compiler_study/CShell/antlr/CShell.g:143:4: ID
					{
					root_0 = (CShellAST)adaptor.nil();


					ID126=(Token)match(input,ID,FOLLOW_ID_in_atom1182); if (state.failed) return retval;
					if ( state.backtracking==0 ) {
					ID126_tree = (CShellAST)adaptor.create(ID126);
					adaptor.addChild(root_0, ID126_tree);
					}

					}
					break;
				case 7 :
					// /compiler_study/CShell/antlr/CShell.g:144:6: call
					{
					root_0 = (CShellAST)adaptor.nil();


					pushFollow(FOLLOW_call_in_atom1190);
					call127=call();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) adaptor.addChild(root_0, call127.getTree());

					}
					break;
				case 8 :
					// /compiler_study/CShell/antlr/CShell.g:145:4: '(' expr ')'
					{
					char_literal128=(Token)match(input,42,FOLLOW_42_in_atom1200); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_42.add(char_literal128);

					pushFollow(FOLLOW_expr_in_atom1202);
					expr129=expr();
					state._fsp--;
					if (state.failed) return retval;
					if ( state.backtracking==0 ) stream_expr.add(expr129.getTree());
					char_literal130=(Token)match(input,43,FOLLOW_43_in_atom1204); if (state.failed) return retval; 
					if ( state.backtracking==0 ) stream_43.add(char_literal130);

					// AST REWRITE
					// elements: expr
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					if ( state.backtracking==0 ) {
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (CShellAST)adaptor.nil();
					// 145:17: -> expr
					{
						adaptor.addChild(root_0, stream_expr.nextTree());
					}


					retval.tree = root_0;
					}

					}
					break;

			}
			retval.stop = input.LT(-1);

			if ( state.backtracking==0 ) {
			retval.tree = (CShellAST)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
			}
		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (CShellAST)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "atom"

	// $ANTLR start synpred3_CShell
	public final void synpred3_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:33:4: ( assign ';' )
		// /compiler_study/CShell/antlr/CShell.g:33:4: assign ';'
		{
		pushFollow(FOLLOW_assign_in_synpred3_CShell192);
		assign();
		state._fsp--;
		if (state.failed) return;

		match(input,47,FOLLOW_47_in_synpred3_CShell195); if (state.failed) return;

		}

	}
	// $ANTLR end synpred3_CShell

	// $ANTLR start synpred4_CShell
	public final void synpred4_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:34:6: ( inc_dec ';' )
		// /compiler_study/CShell/antlr/CShell.g:34:6: inc_dec ';'
		{
		pushFollow(FOLLOW_inc_dec_in_synpred4_CShell206);
		inc_dec();
		state._fsp--;
		if (state.failed) return;

		match(input,47,FOLLOW_47_in_synpred4_CShell208); if (state.failed) return;

		}

	}
	// $ANTLR end synpred4_CShell

	// $ANTLR start synpred10_CShell
	public final void synpred10_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:40:6: ( array_statement_init )
		// /compiler_study/CShell/antlr/CShell.g:40:6: array_statement_init
		{
		pushFollow(FOLLOW_array_statement_init_in_synpred10_CShell322);
		array_statement_init();
		state._fsp--;
		if (state.failed) return;

		}

	}
	// $ANTLR end synpred10_CShell

	// $ANTLR start synpred11_CShell
	public final void synpred11_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:41:6: ( call ';' )
		// /compiler_study/CShell/antlr/CShell.g:41:6: call ';'
		{
		pushFollow(FOLLOW_call_in_synpred11_CShell329);
		call();
		state._fsp--;
		if (state.failed) return;

		match(input,47,FOLLOW_47_in_synpred11_CShell331); if (state.failed) return;

		}

	}
	// $ANTLR end synpred11_CShell

	// $ANTLR start synpred23_CShell
	public final void synpred23_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:105:13: ( INT )
		// /compiler_study/CShell/antlr/CShell.g:105:13: INT
		{
		match(input,INT,FOLLOW_INT_in_synpred23_CShell780); if (state.failed) return;

		}

	}
	// $ANTLR end synpred23_CShell

	// $ANTLR start synpred24_CShell
	public final void synpred24_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:105:17: ( FLOAT )
		// /compiler_study/CShell/antlr/CShell.g:105:17: FLOAT
		{
		match(input,FLOAT,FOLLOW_FLOAT_in_synpred24_CShell782); if (state.failed) return;

		}

	}
	// $ANTLR end synpred24_CShell

	// $ANTLR start synpred25_CShell
	public final void synpred25_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:105:23: ( CHAR )
		// /compiler_study/CShell/antlr/CShell.g:105:23: CHAR
		{
		match(input,CHAR,FOLLOW_CHAR_in_synpred25_CShell784); if (state.failed) return;

		}

	}
	// $ANTLR end synpred25_CShell

	// $ANTLR start synpred26_CShell
	public final void synpred26_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:105:28: ( STRING )
		// /compiler_study/CShell/antlr/CShell.g:105:28: STRING
		{
		match(input,STRING,FOLLOW_STRING_in_synpred26_CShell786); if (state.failed) return;

		}

	}
	// $ANTLR end synpred26_CShell

	// $ANTLR start synpred30_CShell
	public final void synpred30_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:117:11: ( NL )
		// /compiler_study/CShell/antlr/CShell.g:117:11: NL
		{
		match(input,NL,FOLLOW_NL_in_synpred30_CShell884); if (state.failed) return;

		}

	}
	// $ANTLR end synpred30_CShell

	// $ANTLR start synpred31_CShell
	public final void synpred31_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:117:16: ( statement )
		// /compiler_study/CShell/antlr/CShell.g:117:16: statement
		{
		pushFollow(FOLLOW_statement_in_synpred31_CShell888);
		statement();
		state._fsp--;
		if (state.failed) return;

		}

	}
	// $ANTLR end synpred31_CShell

	// $ANTLR start synpred33_CShell
	public final void synpred33_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:117:35: ( NL )
		// /compiler_study/CShell/antlr/CShell.g:117:35: NL
		{
		match(input,NL,FOLLOW_NL_in_synpred33_CShell896); if (state.failed) return;

		}

	}
	// $ANTLR end synpred33_CShell

	// $ANTLR start synpred34_CShell
	public final void synpred34_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:121:7: ( inc_dec )
		// /compiler_study/CShell/antlr/CShell.g:121:7: inc_dec
		{
		pushFollow(FOLLOW_inc_dec_in_synpred34_CShell946);
		inc_dec();
		state._fsp--;
		if (state.failed) return;

		}

	}
	// $ANTLR end synpred34_CShell

	// $ANTLR start synpred35_CShell
	public final void synpred35_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:121:15: ( assign )
		// /compiler_study/CShell/antlr/CShell.g:121:15: assign
		{
		pushFollow(FOLLOW_assign_in_synpred35_CShell948);
		assign();
		state._fsp--;
		if (state.failed) return;

		}

	}
	// $ANTLR end synpred35_CShell

	// $ANTLR start synpred39_CShell
	public final void synpred39_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:121:22: ( ( addexpr ( ( '==' | '<' | '>' ) addexpr )? ) )
		// /compiler_study/CShell/antlr/CShell.g:121:22: ( addexpr ( ( '==' | '<' | '>' ) addexpr )? )
		{
		// /compiler_study/CShell/antlr/CShell.g:121:22: ( addexpr ( ( '==' | '<' | '>' ) addexpr )? )
		// /compiler_study/CShell/antlr/CShell.g:121:23: addexpr ( ( '==' | '<' | '>' ) addexpr )?
		{
		pushFollow(FOLLOW_addexpr_in_synpred39_CShell951);
		addexpr();
		state._fsp--;
		if (state.failed) return;

		// /compiler_study/CShell/antlr/CShell.g:121:31: ( ( '==' | '<' | '>' ) addexpr )?
		int alt33=2;
		int LA33_0 = input.LA(1);
		if ( (LA33_0==EQ||LA33_0==GT||LA33_0==LT) ) {
			alt33=1;
		}
		switch (alt33) {
			case 1 :
				// /compiler_study/CShell/antlr/CShell.g:121:32: ( '==' | '<' | '>' ) addexpr
				{
				if ( input.LA(1)==EQ||input.LA(1)==GT||input.LA(1)==LT ) {
					input.consume();
					state.errorRecovery=false;
					state.failed=false;
				}
				else {
					if (state.backtracking>0) {state.failed=true; return;}
					MismatchedSetException mse = new MismatchedSetException(null,input);
					throw mse;
				}
				pushFollow(FOLLOW_addexpr_in_synpred39_CShell963);
				addexpr();
				state._fsp--;
				if (state.failed) return;

				}
				break;

		}

		}

		}

	}
	// $ANTLR end synpred39_CShell

	// $ANTLR start synpred43_CShell
	public final void synpred43_CShell_fragment() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:126:10: ( ( inc_dec_id '++' ) )
		// /compiler_study/CShell/antlr/CShell.g:126:10: ( inc_dec_id '++' )
		{
		// /compiler_study/CShell/antlr/CShell.g:126:10: ( inc_dec_id '++' )
		// /compiler_study/CShell/antlr/CShell.g:126:11: inc_dec_id '++'
		{
		pushFollow(FOLLOW_inc_dec_id_in_synpred43_CShell1040);
		inc_dec_id();
		state._fsp--;
		if (state.failed) return;

		match(input,44,FOLLOW_44_in_synpred43_CShell1041); if (state.failed) return;

		}

		}

	}
	// $ANTLR end synpred43_CShell

	// Delegated rules

	public final boolean synpred4_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred4_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred11_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred11_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred30_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred30_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred24_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred24_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred26_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred26_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred33_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred33_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred39_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred39_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred35_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred35_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred43_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred43_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred23_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred23_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred34_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred34_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred10_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred10_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred25_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred25_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred31_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred31_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}
	public final boolean synpred3_CShell() {
		state.backtracking++;
		int start = input.mark();
		try {
			synpred3_CShell_fragment(); // can never throw exception
		} catch (RecognitionException re) {
			System.err.println("impossible: "+re);
		}
		boolean success = !state.failed;
		input.rewind(start);
		state.backtracking--;
		state.failed=false;
		return success;
	}



	public static final BitSet FOLLOW_function_definition_in_program164 = new BitSet(new long[]{0x0000501A06102000L});
	public static final BitSet FOLLOW_statement_in_program167 = new BitSet(new long[]{0x0000501A06102000L});
	public static final BitSet FOLLOW_EOF_in_program171 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_in_statement192 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_statement195 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_in_statement206 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_statement208 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_RETURN_in_statement225 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_statement227 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_statement229 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_PRINT_in_statement246 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_statement248 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_statement250 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_statement252 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_statement254 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_IF_in_statement271 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_statement273 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_statement275 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_statement277 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_slist_in_statement279 = new BitSet(new long[]{0x0004000000000000L});
	public static final BitSet FOLLOW_elseif_statement_all_in_statement281 = new BitSet(new long[]{0x0004000000000002L});
	public static final BitSet FOLLOW_else_statement_in_statement284 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_for_statement_in_statement315 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_statement_init_in_statement322 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_call_in_statement329 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_statement331 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NL_in_statement358 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_DEF_in_function_definition383 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_ID_in_function_definition385 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_function_definition400 = new BitSet(new long[]{0x0000080002000000L});
	public static final BitSet FOLLOW_vardef_in_function_definition403 = new BitSet(new long[]{0x0000280000000000L});
	public static final BitSet FOLLOW_45_in_function_definition406 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_vardef_in_function_definition408 = new BitSet(new long[]{0x0000280000000000L});
	public static final BitSet FOLLOW_43_in_function_definition415 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_slist_in_function_definition425 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ID_in_vardef448 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ID_in_call467 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_call469 = new BitSet(new long[]{0x00005C4032080800L});
	public static final BitSet FOLLOW_expr_in_call472 = new BitSet(new long[]{0x0000280000000000L});
	public static final BitSet FOLLOW_45_in_call475 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_call477 = new BitSet(new long[]{0x0000280000000000L});
	public static final BitSet FOLLOW_43_in_call484 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_50_in_else_statement503 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_slist_in_else_statement505 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_50_in_elseif_statement_all515 = new BitSet(new long[]{0x0000000004000000L});
	public static final BitSet FOLLOW_IF_in_elseif_statement_all517 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_elseif_statement_all519 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_elseif_statement_all521 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_elseif_statement_all523 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_slist_in_elseif_statement_all526 = new BitSet(new long[]{0x0004000000000002L});
	public static final BitSet FOLLOW_FOR_in_for_statement553 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_for_statement555 = new BitSet(new long[]{0x0000800002000000L});
	public static final BitSet FOLLOW_for1_in_for_statement582 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_for_statement608 = new BitSet(new long[]{0x0000D44032080800L});
	public static final BitSet FOLLOW_for2_in_for_statement610 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_for_statement624 = new BitSet(new long[]{0x00005C4032080800L});
	public static final BitSet FOLLOW_for3_in_for_statement626 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_for_statement629 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_slist_in_for_statement631 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_in_for1701 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_45_in_for1703 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_assign_in_for1705 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_expr_in_for2717 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_expr_in_for3723 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_45_in_for3725 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_for3727 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_ID_in_array_statement_init747 = new BitSet(new long[]{0x0000000000000100L});
	public static final BitSet FOLLOW_ASSIGN_in_array_statement_init749 = new BitSet(new long[]{0x0001000000000000L});
	public static final BitSet FOLLOW_48_in_array_statement_init751 = new BitSet(new long[]{0x0002544032080800L});
	public static final BitSet FOLLOW_array_values_in_array_statement_init753 = new BitSet(new long[]{0x0002000000000000L});
	public static final BitSet FOLLOW_49_in_array_statement_init756 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_array_statement_init757 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_INT_in_array_value780 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_FLOAT_in_array_value782 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_CHAR_in_array_value784 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_STRING_in_array_value786 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_expr_in_array_value788 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_value_in_array_values793 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_45_in_array_values795 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_array_value_in_array_values797 = new BitSet(new long[]{0x0000200000000002L});
	public static final BitSet FOLLOW_ID_in_array_element815 = new BitSet(new long[]{0x0001000000000000L});
	public static final BitSet FOLLOW_48_in_array_element816 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_array_element822 = new BitSet(new long[]{0x0002000000000000L});
	public static final BitSet FOLLOW_49_in_array_element824 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ID_in_assign_id841 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_element_in_assign_id844 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_id_in_assign853 = new BitSet(new long[]{0x0000000000000100L});
	public static final BitSet FOLLOW_ASSIGN_in_assign855 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_assign857 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NL_in_slist880 = new BitSet(new long[]{0x0008000200000000L});
	public static final BitSet FOLLOW_51_in_slist882 = new BitSet(new long[]{0x0010501A06100000L});
	public static final BitSet FOLLOW_NL_in_slist884 = new BitSet(new long[]{0x0010501A06100000L});
	public static final BitSet FOLLOW_statement_in_slist888 = new BitSet(new long[]{0x0010501A06100000L});
	public static final BitSet FOLLOW_NL_in_slist892 = new BitSet(new long[]{0x0010000200000000L});
	public static final BitSet FOLLOW_52_in_slist895 = new BitSet(new long[]{0x0000000200000002L});
	public static final BitSet FOLLOW_NL_in_slist896 = new BitSet(new long[]{0x0000000200000002L});
	public static final BitSet FOLLOW_LENGTH_in_length_fun920 = new BitSet(new long[]{0x0000040000000000L});
	public static final BitSet FOLLOW_42_in_length_fun922 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_assign_id_in_length_fun924 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_length_fun926 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_in_expr946 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_in_expr948 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_addexpr_in_expr951 = new BitSet(new long[]{0x0000000081020002L});
	public static final BitSet FOLLOW_set_in_expr954 = new BitSet(new long[]{0x0000044012080800L});
	public static final BitSet FOLLOW_addexpr_in_expr963 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_length_fun_in_expr977 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ID_in_inc_dec_id983 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_element_in_inc_dec_id986 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_44_in_inc_dec994 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_inc_dec_id_in_inc_dec997 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_46_in_inc_dec1018 = new BitSet(new long[]{0x0000000002000000L});
	public static final BitSet FOLLOW_inc_dec_id_in_inc_dec1019 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_id_in_inc_dec1040 = new BitSet(new long[]{0x0000100000000000L});
	public static final BitSet FOLLOW_44_in_inc_dec1041 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_id_in_inc_dec1062 = new BitSet(new long[]{0x0000400000000000L});
	public static final BitSet FOLLOW_46_in_inc_dec1063 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_mulexpr_in_addexpr1084 = new BitSet(new long[]{0x0000008000000012L});
	public static final BitSet FOLLOW_set_in_addexpr1087 = new BitSet(new long[]{0x0000044012080800L});
	public static final BitSet FOLLOW_mulexpr_in_addexpr1094 = new BitSet(new long[]{0x0000008000000012L});
	public static final BitSet FOLLOW_atom_in_mulexpr1111 = new BitSet(new long[]{0x0000000100004002L});
	public static final BitSet FOLLOW_set_in_mulexpr1114 = new BitSet(new long[]{0x0000044012080800L});
	public static final BitSet FOLLOW_atom_in_mulexpr1121 = new BitSet(new long[]{0x0000000100004002L});
	public static final BitSet FOLLOW_INT_in_atom1137 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_CHAR_in_atom1148 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_FLOAT_in_atom1158 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_STRING_in_atom1168 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_element_in_atom1176 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_ID_in_atom1182 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_call_in_atom1190 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_42_in_atom1200 = new BitSet(new long[]{0x0000544032080800L});
	public static final BitSet FOLLOW_expr_in_atom1202 = new BitSet(new long[]{0x0000080000000000L});
	public static final BitSet FOLLOW_43_in_atom1204 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_in_synpred3_CShell192 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_synpred3_CShell195 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_in_synpred4_CShell206 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_synpred4_CShell208 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_array_statement_init_in_synpred10_CShell322 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_call_in_synpred11_CShell329 = new BitSet(new long[]{0x0000800000000000L});
	public static final BitSet FOLLOW_47_in_synpred11_CShell331 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_INT_in_synpred23_CShell780 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_FLOAT_in_synpred24_CShell782 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_CHAR_in_synpred25_CShell784 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_STRING_in_synpred26_CShell786 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NL_in_synpred30_CShell884 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_statement_in_synpred31_CShell888 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_NL_in_synpred33_CShell896 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_in_synpred34_CShell946 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_assign_in_synpred35_CShell948 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_addexpr_in_synpred39_CShell951 = new BitSet(new long[]{0x0000000081020002L});
	public static final BitSet FOLLOW_set_in_synpred39_CShell954 = new BitSet(new long[]{0x0000044012080800L});
	public static final BitSet FOLLOW_addexpr_in_synpred39_CShell963 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_inc_dec_id_in_synpred43_CShell1040 = new BitSet(new long[]{0x0000100000000000L});
	public static final BitSet FOLLOW_44_in_synpred43_CShell1041 = new BitSet(new long[]{0x0000000000000002L});
}
